
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("ImportExport")){
if(AjxPackage.define("zimbraMail.share.controller.ZmImportExportController")){
ZmImportExportController=function(){
ZmController.call(this,null)
};
ZmImportExportController.prototype=new ZmController;
ZmImportExportController.prototype.constructor=ZmImportExportController;
ZmImportExportController.prototype.toString=function(){
return"ZmImportExportController"
};
ZmImportExportController.IMPORT_TIMEOUT=300;
ZmImportExportController.TYPE_CSV="csv";
ZmImportExportController.TYPE_ICS="ics";
ZmImportExportController.TYPE_TGZ="tgz";
ZmImportExportController.TYPE_DEFAULT=ZmImportExportController.TYPE_TGZ;
ZmImportExportController.SUBTYPE_DEFAULT={};
ZmImportExportController.SUBTYPE_DEFAULT[ZmImportExportController.TYPE_TGZ]=ZmImportExportController.SUBTYPE_ZIMBRA_TGZ;
ZmImportExportController.SUBTYPE_DEFAULT[ZmImportExportController.TYPE_CSV]=ZmImportExportController.SUBTYPE_ZIMBRA_CSV;
ZmImportExportController.SUBTYPE_DEFAULT[ZmImportExportController.TYPE_ICS]=ZmImportExportController.SUBTYPE_ZIMBRA_ICS;
ZmImportExportController.TYPE_EXTS={};
ZmImportExportController.TYPE_EXTS[ZmImportExportController.TYPE_CSV]=["csv","vcf"];
ZmImportExportController.TYPE_EXTS[ZmImportExportController.TYPE_ICS]=["ics"];
ZmImportExportController.TYPE_EXTS[ZmImportExportController.TYPE_TGZ]=["tgz","zip"];
ZmImportExportController.EXTS_TYPE={};
for(var p in ZmImportExportController.TYPE_EXTS){
for(var i=0;
i<ZmImportExportController.TYPE_EXTS[p].length;
i++){
ZmImportExportController.EXTS_TYPE[ZmImportExportController.TYPE_EXTS[p][i]]=p
}}
delete p;
delete i;
ZmImportExportController.__FAULT_ARGS_MAPPING={
"formatter.INVALID_FORMAT":["filename"],"formatter.INVALID_TYPE":["view","path"],"formatter.MISMATCHED_META":["path"],"formatter.MISMATCHED_SIZE":["path"],"formatter.MISMATCHED_TYPE":["path"],"formatter.MISSING_BLOB":["path"],"formatter.MISSING_META":["path"],"formatter.MISSING_VCARD_FIELDS":["path"],"formatter.UNKNOWN_ERROR":["path","message"]};
ZmImportExportController.prototype.importData=function(r){
r=r||{};
var e=r.folderId||-1;
if(e==-1){
var r={
msg:ZmMsg.importErrorMissingFolder,level:ZmStatusView.LEVEL_CRITICAL};
appCtxt.setStatusMsg(r);
return false
}
r.filename=r.form&&r.form.elements.file.value;
if(!r.filename){
var r={
msg:ZmMsg.importErrorMissingFile,level:ZmStatusView.LEVEL_CRITICAL};
appCtxt.setStatusMsg(r);
return false
}
r.ext=r.filename.replace(/^.*\./,"").toLowerCase();
r.defaultType=r.type||ZmImportExportController.EXTS_TYPE[r.ext]||ZmImportExportController.TYPE_DEFAULT;
var n=ZmImportExportController.EXTS_TYPE[r.defaultType]==ZmImportExportController.TYPE_TGZ;
var o=appCtxt.getById(e);
if(!n&&o&&o.nId==ZmOrganizer.ID_ROOT){
var r={
msg:ZmMsg.importErrorRootNotAllowed,level:ZmStatusView.LEVEL_CRITICAL};
appCtxt.setStatusMsg(r);
return false
}
if(r.resolve=="reset"){
var t=appCtxt.getOkCancelMsgDialog();
t.registerCallback(DwtDialog.OK_BUTTON,this._confirmImportReset,this,[r]);
t.registerCallback(DwtDialog.CANCEL_BUTTON,this._cancelImportReset,this);
var s=ZmMsg.importResetWarning;
var a=DwtMessageDialog.WARNING_STYLE;
t.setMessage(s,a);
t.popup();
return false
}
return this._doImportData(r)
};
ZmImportExportController.prototype.exportData=function(n){
n=n||{};
var e=n.folderId||-1;
if(e==-1){
var n={
msg:ZmMsg.exportErrorMissingFolder,level:ZmStatusView.LEVEL_CRITICAL};
appCtxt.setStatusMsg(n);
return false
}
var t=n.type=n.type||ZmImportExportController.TYPE_DEFAULT;
var o=ZmImportExportController.EXTS_TYPE[t]==ZmImportExportController.TYPE_TGZ;
var a=appCtxt.getById(e);
if(!o&&a&&a.nId==ZmOrganizer.ID_ROOT){
var n={
msg:ZmMsg.exportErrorRootNotAllowed,level:ZmStatusView.LEVEL_CRITICAL};
appCtxt.setStatusMsg(n);
return false
}
return this._doExportData(n)
};
ZmImportExportController.prototype._doImportData=function(e){
if(e.folderId==-1&&e.defaultType!=ZmImportExportController.TYPE_TGZ){
return this._doImportSelectFolder(e)
}
return this._doImport(e)
};
ZmImportExportController.prototype._doImportSelectFolder=function(s){
var e=appCtxt.getChooseFolderDialog();
e.reset();
e.setTitle(ZmMsg._import);
e.registerCallback(DwtDialog.OK_BUTTON,this._doImportSelectFolderDone,this,[s]);
var n=e.getOverviewId(ZmSetting.IMPORT);
var a={};
a[ZmFolder.ID_TRASH]=true;
var t=s.defaultType;
if(t==ZmImportExportController.TYPE_CSV){
AjxDispatcher.require(["ContactsCore","Contacts"]);
var o=!appCtxt.get(ZmSetting.NEW_ADDR_BOOK_ENABLED);
e.popup({
treeIds:[ZmOrganizer.ADDRBOOK],title:ZmMsg.chooseAddrBook,overviewId:n,description:ZmMsg.chooseAddrBookToImport,skipReadOnly:true,hideNewButton:o,omit:a,appName:ZmApp.CONTACTS}
)
}else{
if(t==ZmImportExportController.TYPE_ICS){
AjxDispatcher.require(["CalendarCore","Calendar"]);
e.popup({
treeIds:[ZmOrganizer.CALENDAR],title:ZmMsg.chooseCalendar,overviewId:n,description:ZmMsg.chooseCalendarToImport,skipReadOnly:true,omit:a,appName:ZmApp.CALENDAR}
)
}}};
ZmImportExportController.prototype._doImportSelectFolderDone=function(t,e){
t.folderId=e.id;
this._doImport(t)
};
ZmImportExportController.prototype._doImport=function(o){
var r="ZmImportExportController__callback__"+Dwt.getNextId("import");
window[r]=AjxCallback.simpleClosure(this._handleImportResponse,this,r,o);
var t=o.folderId&&appCtxt.getById(o.folderId);
if(t&&t.nId==ZmOrganizer.ID_ROOT){
t=null
}
var l=t?t.getPath(null,null,null,true,true):"";
var h=o.type||o.ext;
var e=["/home/",encodeURIComponent(appCtxt.get(ZmSetting.USERNAME)),"/",encodeURIComponent(l),"?",h?"fmt="+encodeURIComponent(h):"",o.views?"&types="+encodeURIComponent(o.views):"",o.resolve?"&resolve="+encodeURIComponent(o.resolve):"","&callback="+r,"&charset="+appCtxt.getCharset()].join("");
var a=o.form;
a.action=e;
a.method="POST";
a.enctype="multipart/form-data";
var n=null;
var s=AjxCallback.simpleClosure(this._importError,this,o.errorCallback);
o.iframe=ZmImportExportController.__createIframe(a,n,s);
a.submit();
return true
};
ZmImportExportController.prototype._handleImportResponse=function(f,o,g,n){
var r=[];
if(n){
for(var h=3;
h<arguments.length;
h++){
var m=arguments[h];
var t=m.Detail.Error.Code;
var y=m.Reason.Text;
var u=ZmImportExportController.__faultArgs(m.Detail.Error.a);
if(t=="formatter.UNKNOWN_ERROR"){
u.path=u.path||["(",ZmMsg.unknown,")"].join("");
u.message=y
}
var c=ZmImportExportController.__FAULT_ARGS_MAPPING[t];
var a=new Array(c?c.length:0);
for(var l=0;
l<a.length;
l++){
a[l]=u[c[l]]
}
r.push(ZMsg[t]?AjxMessageFormat.format(ZMsg[t],a):y)
}}
if(g=="fail"){
this._importError(o.errorCallback,r[0])
}else{
if(g=="warn"){
this._importWarnings(o.callback,r)
}else{
this._importSuccess(o.callback);
appCtxt.getAppController().sendNoOp()
}}
try{
delete window[f]
}
catch(d){
if(window[f]){
window[f]=undefined
}}
var s=o.iframe;
setTimeout(function(){
s.parentNode.removeChild(s)
}
,0)
};
ZmImportExportController.__faultArgs=function(a){
var e={};
for(var t=0;
a&&t<a.length;
t++){
e[a[t].n]=a[t]._content
}
return e
};
ZmImportExportController.prototype._confirmImportReset=function(e){
this._cancelImportReset();
this._doImportData(e)
};
ZmImportExportController.prototype._cancelImportReset=function(){
var e=appCtxt.getOkCancelMsgDialog();
e.reset();
e.popdown()
};
ZmImportExportController.prototype._doExportData=function(s){
var d=s.type;
var l=d==ZmImportExportController.TYPE_TGZ;
var u=d==ZmImportExportController.TYPE_CSV;
var m=s.subType||ZmImportExportController.SUBTYPE_DEFAULT[d];
var a=s.folderId&&appCtxt.getById(s.folderId);
if(a&&a.nId==ZmOrganizer.ID_ROOT){
a=null
}
var g=a?a.getPath(null,null,null,true,true):"";
var e=["/home/",encodeURIComponent(appCtxt.get(ZmSetting.USERNAME)),"/",encodeURIComponent(g)].join("");
var f={
fmt:d};
if(u){
f[d+"fmt"]=m
}
if(l&&s.views){
f.types=s.views
}
if(s.views=="appointment"){
var o=s.start?AjxDateUtil.simpleParseDateStr(s.start):null;
var h=s.end?AjxDateUtil.simpleParseDateStr(s.end):null;
if(o){
f.start=o.getTime()
}
if(h){
h=AjxDateUtil.roll(h,AjxDateUtil.DAY,1);
f.end=h.getTime()
}}else{
if(l&&s.start){
s.searchFilter=(s.searchFilter)?s.searchFilter+" AND ":"after:"+s.start
}
if(l&&s.end){
s.searchFilter=((s.searchFilter)?s.searchFilter+" AND ":"")+"before:"+s.end
}}
if(l&&s.searchFilter){
f.query=s.searchFilter
}
if(s.skipMeta){
f.meta="0"
}
if(s.filename){
f.filename=s.filename
}
f.emptyname=ZmMsg.exportEmptyName;
f.charset=appCtxt.getCharset();
var t=ZmImportExportController.__createForm(e,f);
var n=AjxCallback.simpleClosure(this._exportSuccess,this,s.callback);
var c=AjxCallback.simpleClosure(this._exportError,this,s.errorCallback);
var r=ZmImportExportController.__createIframe(t,n,c);
t.submit()
};
ZmImportExportController.prototype._importSuccess=function(e){
if(e){
e.run(true)
}
ZmImportExportController.__showMessage(ZmMsg.importSuccess,DwtMessageDialog.INFO_STYLE);
return true
};
ZmImportExportController.prototype._importWarnings=function(r,o){
if(r){
r.run(false)
}
var n={};
for(var e=0;
e<o.length;
e++){
n[o[e]]=true
}
o=AjxUtil.map(AjxUtil.keys(n),AjxStringUtil.htmlEncode);
if(o.length>5){
var a=o.length-5;
o.splice(5,a,AjxMessageFormat.format(ZmMsg.importAdditionalWarnings,[a]))
}
var t=[];
for(var e=0;
e<o.length;
e++){
t.push("<li>",o[e])
}
var s=AjxMessageFormat.format(ZmMsg.importSuccessWithWarnings,[o.length,t.join("")]);
ZmImportExportController.__showMessage(s,DwtMessageDialog.WARNING_STYLE);
return true
};
ZmImportExportController.prototype._importError=function(e,t){
if(e){
e.run(false)
}
var a=AjxStringUtil.htmlEncode(t)||ZmMsg.importFailed;
ZmImportExportController.__showMessage(a,DwtMessageDialog.CRITICAL_STYLE);
return true
};
ZmImportExportController.prototype._exportSuccess=function(e){
if(e){
e.run(true)
}
ZmImportExportController.__showMessage(ZmMsg.exportSuccess,DwtMessageDialog.INFO_STYLE);
return true
};
ZmImportExportController.prototype._exportError=function(e){
if(e){
e.run(false)
}
ZmImportExportController.__showMessage(ZmMsg.exportFailed,DwtMessageDialog.CRITICAL_STYLE);
return true
};
ZmImportExportController.__showMessage=function(t,a){
var e=appCtxt.getErrorDialog();
e.setMessage(t,null,a);
e.popup(null,true)
};
ZmImportExportController.__createForm=function(n,s,r){
var a=document.createElement("FORM");
a.action=n;
a.method=r||"GET";
for(var t in s){
var o=s[t];
if(!o){
continue
}
var e=document.createElement("INPUT");
e.type="hidden";
e.name=t;
e.value=o;
a.appendChild(e)
}
a.style.display="none";
document.body.appendChild(a);
return a
};
ZmImportExportController.__createIframe=function(o,n,e){
var s=Dwt.getNextId()+"_iframe";
var a;
if(AjxEnv.isIE){
var t=["<IFRAME id='",s,"' name='",s,"'>"].join("");
a=document.createElement(t)
}else{
a=document.createElement("IFRAME");
a.name=a.id=s
}
a.style.position="absolute";
a.style.width=1;
a.style.height=1;
a.style.top=10;
a.style.left=-10;
document.body.appendChild(a);
o.target=a.name;
a.onload=n;
a.onerror=e;
return a
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmImportExportBaseView")){
ZmImportExportBaseView=function(e){
if(arguments.length==0){
return
}
DwtForm.call(this,e);
this._initSubType(ZmImportExportController.TYPE_CSV);
this._setFolderButton(appCtxt.getById(ZmOrganizer.ID_ROOT))
};
ZmImportExportBaseView.prototype=new DwtForm;
ZmImportExportBaseView.prototype.constructor=ZmImportExportBaseView;
ZmImportExportBaseView.prototype.toString=function(){
return"ZmImportExportBaseView"
};
ZmImportExportBaseView.prototype._folderId=-1;
ZmImportExportBaseView.prototype.getFolderId=function(){
return this._folderId
};
ZmImportExportBaseView.prototype.update=function(){
DwtForm.prototype.update.apply(this,arguments);
var e=this.getValue("TYPE",ZmImportExportController.TYPE_TGZ);
this.setValue("TYPE_HINT",this.TYPE_HINTS[e])
};
ZmImportExportBaseView.prototype.setValue=function(e,o){
var n=this.getValue(e);
DwtForm.prototype.setValue.apply(this,arguments);
if(e=="TYPE"&&o!=n){
var t=o;
this._initSubType(t);
var s=t==ZmImportExportController.TYPE_TGZ;
this.setEnabled("ADVANCED",s);
if(this.getValue("ADVANCED")&&!s){
this.setValue("ADVANCED",false);
this.update()
}
var a;
switch(t){
case ZmImportExportController.TYPE_CSV:a=appCtxt.getById(ZmOrganizer.ID_ADDRBOOK);
break;
case ZmImportExportController.TYPE_ICS:a=appCtxt.getById(ZmOrganizer.ID_CALENDAR);
break;
case ZmImportExportController.TYPE_TGZ:a=appCtxt.getById(ZmOrganizer.ID_ROOT);
break
}
this._setFolderButton(a)
}};
ZmImportExportBaseView.prototype._initSubType=function(o){
var e=this.getControl("SUBTYPE");
if(!e){
return
}
var t=this._getSubTypeOptions(o);
if(!t||t.length==0){
return
}
e.clearOptions();
for(var a=0;
a<t.length;
a++){
e.addOption(t[a])
}
e.setSelectedValue(t[0].value)
};
ZmImportExportBaseView.prototype._getSubTypeOptions=function(o){
if(!ZmImportExportBaseView.prototype.TGZ_OPTIONS){
ZmImportExportBaseView.prototype.TGZ_OPTIONS=[{
displayValue:ZmMsg["zimbra-tgz"],value:"zimbra-tgz"}
];
ZmImportExportBaseView.prototype.CSV_OPTIONS=[];
var e=appCtxt.get(ZmSetting.AVAILABLE_CSVFORMATS);
for(var a=0;
a<e.length;
a++){
var n=e[a];
if(n){
ZmImportExportBaseView.prototype.CSV_OPTIONS.push({
displayValue:ZmMsg[n]||n,value:n}
)
}}
ZmImportExportBaseView.prototype.ICS_OPTIONS=[{
displayValue:ZmMsg["zimbra-ics"],value:"zimbra-ics"}
]
}
var t;
switch(o){
case ZmImportExportController.TYPE_TGZ:t=this.TGZ_OPTIONS;
break;
case ZmImportExportController.TYPE_CSV:t=this.CSV_OPTIONS;
break;
case ZmImportExportController.TYPE_ICS:t=this.ICS_OPTIONS;
break
}
return t
};
ZmImportExportBaseView.prototype._type_onclick=function(e,t){
var a=this.getValue("TYPE");
this.setValue("TYPE",a)
};
ZmImportExportBaseView.prototype._folderButton_onclick=function(){
if(!this._handleFolderDialogOkCallback){
this._handleFolderDialogOkCallback=new AjxCallback(this,this._handleFolderDialogOk)
}
if(!this._TREES){
this._TREES={};
this._TREES[ZmImportExportController.TYPE_TGZ]=[];
for(var s in ZmOrganizer.VIEWS){
var o=ZmApp.SETTING[ZmOrganizer.APP2ORGANIZER_R[s]];
if(o==null||appCtxt.get(o)){
this._TREES[ZmImportExportController.TYPE_TGZ].push(s)
}}
this._TREES[ZmImportExportController.TYPE_CSV]=appCtxt.get(ZmSetting.CONTACTS_ENABLED)?[ZmOrganizer.ADDRBOOK]:[];
this._TREES[ZmImportExportController.TYPE_ICS]=appCtxt.get(ZmSetting.CALENDAR_ENABLED)?[ZmOrganizer.CALENDAR]:[]
}
var e=appCtxt.getChooseFolderDialog();
e.registerCallback(DwtDialog.OK_BUTTON,this._handleFolderDialogOkCallback);
var t=this.getValue("TYPE")||ZmImportExportController.TYPE_TGZ;
var a=appCtxt.multiAccounts?appCtxt.getActiveAccount().name:"";
var n={
treeIds:this._TREES[t],overviewId:e.getOverviewId([this.toString(),t,a].join("_")),description:"",skipReadOnly:true,omit:{}
,forceSingle:true,hideNewButton:(this instanceof ZmExportView)};
n.omit[ZmOrganizer.ID_TRASH]=true;
e.popup(n)
};
ZmImportExportBaseView.prototype._handleFolderDialogOk=function(e){
appCtxt.getChooseFolderDialog().popdown();
this._setFolderButton(e);
return true
};
ZmImportExportBaseView.prototype._setFolderButton=function(t){
this._folderId=t?t.id:-1;
if(t){
var e=t.nId==ZmOrganizer.ID_ROOT;
this.setLabel("FOLDER_BUTTON",e?ZmMsg.allFolders:AjxStringUtil.htmlEncode(t.name))
}else{
this.setLabel("FOLDER_BUTTON",ZmMsg.browse)
}};
ZmImportExportDataTypes=function(e){
if(arguments.length==0){
return
}
DwtComposite.apply(this,arguments);
this._tabGroup=new DwtTabGroup(this._htmlElId);
this._createHtml()
};
ZmImportExportDataTypes.prototype=new DwtComposite;
ZmImportExportDataTypes.prototype.constructor=ZmImportExportDataTypes;
ZmImportExportDataTypes.prototype.toString=function(){
return"ZmImportExportDataTypes"
};
ZmImportExportDataTypes.prototype.TEMPLATE="data.ImportExport#DataTypes";
ZmImportExportDataTypes.prototype.getTabGroupMember=function(){
return this._tabGroup
};
ZmImportExportDataTypes.prototype.setValue=function(h){
if(h==""){
var o=this.getChildren();
for(var a=0;
a<o.length;
a++){
var r=o[a];
r.setSelected(true)
}
return
}
var t=h?h.split(","):[];
var s={};
for(var a=0;
a<t.length;
a++){
s[t[a]]=true
}
var o=this.getChildren();
for(var a=0;
a<o.length;
a++){
var r=o[a];
var n=true;
var t=r.getValue().split(",");
for(var e=0;
e<t.length;
e++){
if(!s[t[e]]){
n=false;
break
}}
r.setSelected(n)
}};
ZmImportExportDataTypes.prototype.getValue=function(){
if(this.isAllSelected()){
return""
}
var a=[];
var t=this.getChildren();
for(var e=0;
e<t.length;
e++){
var o=t[e];
if(o.isSelected()){
a.push(o.getValue())
}}
return a.join(",")
};
ZmImportExportDataTypes.prototype.isAllSelected=function(){
var t=this.getChildren();
for(var e=0;
e<t.length;
e++){
var a=t[e];
if(!a.isSelected()){
return false
}}
return true
};
ZmImportExportDataTypes.prototype.setEnabled=function(e){
DwtComposite.prototype.setEnabled.apply(this,arguments);
var a=this.getChildren();
for(var t=0;
t<a.length;
t++){
var o=a[t];
o.setEnabled(e)
}};
ZmImportExportDataTypes.prototype._createHtml=function(e){
this._createHtmlFromTemplate(e||this.TEMPLATE,{
id:this._htmlElId}
)
};
ZmImportExportDataTypes.prototype._createHtmlFromTemplate=function(o,s){
s.count=0;
for(var e in ZmApp.ORGANIZER){
var r=ZmApp.ORGANIZER[e];
var t=ZmOrganizer.VIEWS[r];
if(!t||t.length==0){
continue
}
s.count++
}
DwtComposite.prototype._createHtmlFromTemplate.call(this,o,s);
var a=0;
for(var e in ZmApp.ORGANIZER){
var r=ZmApp.ORGANIZER[e];
var t=ZmOrganizer.VIEWS[r];
if(!t||t.length==0){
continue
}
var n=new ZmImportExportDataTypeCheckbox({
parent:this,checked:true}
);
n.setImage(ZmApp.ICON[e]);
n.setText(ZmMsg[ZmApp.NAME[e]]||e);
n.setValue(t.join(","));
n.replaceElement(s.id+"_cell_"+a);
this._tabGroup.addMember(n);
a++
}};
ZmImportExportDataTypeCheckbox=function(e){
if(arguments.length==0){
return
}
DwtCheckbox.apply(this,arguments)
};
ZmImportExportDataTypeCheckbox.prototype=new DwtCheckbox;
ZmImportExportDataTypeCheckbox.prototype.constructor=ZmImportExportDataTypeCheckbox;
ZmImportExportDataTypeCheckbox.prototype.TEMPLATE="data.ImportExport#DataTypeCheckbox";
ZmImportExportDataTypeCheckbox.prototype.setTextPosition=function(e){
DwtCheckbox.prototype.setTextPosition.call(this,DwtCheckbox.TEXT_RIGHT)
};
ZmImportExportDataTypeCheckbox.prototype.setImage=function(e){
if(this._imageEl){
this._imageEl.className=AjxImg.getClassForImage(e)
}};
ZmImportExportDataTypeCheckbox.prototype._createHtmlFromTemplate=function(e,t){
DwtCheckbox.prototype._createHtmlFromTemplate.apply(this,arguments);
this._imageEl=document.getElementById(t.id+"_image")
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmExportView")){
ZmExportView=function(e){
if(arguments.length==0){
return
}
e.form={
items:[{
id:"TYPE",type:"DwtRadioButtonGroup",value:ZmImportExportController.TYPE_TGZ,items:[{
id:"TYPE_TGZ",label:ZmMsg.importExportTypeTGZ,value:ZmImportExportController.TYPE_TGZ}
,{
id:"TYPE_ICS",label:ZmMsg.importExportTypeICS,value:ZmImportExportController.TYPE_ICS}
,{
id:"TYPE_CSV",label:ZmMsg.importExportTypeCSV,value:ZmImportExportController.TYPE_CSV}
],onclick:this._type_onclick}
,{
id:"TYPE_HINT",type:"DwtText"}
,{
id:"SUBTYPE",type:"DwtSelect",visible:"get('TYPE') == ZmImportExportController.TYPE_CSV"}
,{
id:"FOLDER_BUTTON",type:"DwtButton",label:ZmMsg.browse,onclick:this._folderButton_onclick}
,{
id:"ADVANCED",type:"DwtCheckbox",label:ZmMsg.advancedSettings,visible:"get('TYPE') == ZmImportExportController.TYPE_TGZ"}
,{
id:"DATA_TYPES",type:"ZmImportExportDataTypes",visible:"get('ADVANCED')"}
,{
id:"SEARCH_FILTER",type:"DwtInputField",hint:ZmMsg.searchFilterHint,visible:"get('ADVANCED')"}
,{
id:"DATE_row",visible:"get('ADVANCED')"}
,{
id:"startDateField",type:"DwtInputField",visible:"get('ADVANCED')",onblur:AjxCallback.simpleClosure(this._dateFieldChangeListener,this,true)}
,{
id:"startMiniCalBtn",type:"DwtButton",visible:"get('ADVANCED')",menu:{
type:"DwtCalendar",id:"startMiniCal",onselect:new AjxListener(this,this._dateCalSelectionListener,[true])}}
,{
id:"endDateField",type:"DwtInputField",visible:"get('ADVANCED')",onblur:AjxCallback.simpleClosure(this._dateFieldChangeListener,this,false)}
,{
id:"endMiniCalBtn",type:"DwtButton",visible:"get('ADVANCED')",menu:{
type:"DwtCalendar",id:"endMiniCal",onselect:new AjxListener(this,this._dateCalSelectionListener,[false])}}
,{
id:"SKIP_META",type:"DwtCheckbox",label:ZmMsg.exportSkipMeta,visible:"get('ADVANCED')"}
]};
e.id="ZmExportView";
ZmImportExportBaseView.call(this,e)
};
ZmExportView.prototype=new ZmImportExportBaseView;
ZmExportView.prototype.constructor=ZmExportView;
ZmExportView.prototype.toString=function(){
return"ZmExportView"
};
ZmExportView.prototype.TYPE_HINTS={};
ZmExportView.prototype.TYPE_HINTS[ZmImportExportController.TYPE_CSV]=ZmMsg.exportToCSVHint;
ZmExportView.prototype.TYPE_HINTS[ZmImportExportController.TYPE_ICS]=ZmMsg.exportToICSHint;
ZmExportView.prototype.TYPE_HINTS[ZmImportExportController.TYPE_TGZ]=ZmMsg.exportToTGZHint;
ZmExportView.prototype.TEMPLATE="data.ImportExport#ExportView";
ZmExportView.prototype._type=ZmImportExportController.TYPE_TGZ;
ZmExportView.prototype.getParams=function(){
var a={
type:this.getValue("TYPE",ZmImportExportController.TYPE_TGZ),subType:this.getValue("SUBTYPE"),views:this.isRelevant("DATA_TYPES")?this.getValue("DATA_TYPES"):null,folderId:this._folderId,searchFilter:this.isRelevant("SEARCH_FILTER")?this.getValue("SEARCH_FILTER"):null,start:this.isRelevant("startDateField")?this.getValue("startDateField"):null,end:this.isRelevant("endDateField")?this.getValue("endDateField"):null,skipMeta:this.isRelevant("SKIP_META")?this.getValue("SKIP_META"):null};
if(this._folderId!=-1){
var t=appCtxt.getById(a.folderId);
var e=t&&t.nId==ZmOrganizer.ID_ROOT;
a.filename=[e?ZmMsg.exportFilenamePrefixAllFolders:t.name,"-",AjxDateFormat.format("yyyy-MM-dd-HHmmss",new Date())].join("");
a.filename=a.filename
}
return a
};
ZmExportView.prototype.update=function(){
var t=this.getValue("TYPE",ZmImportExportController.TYPE_TGZ);
var e=t==ZmImportExportController.TYPE_TGZ;
var a=this.getControl("ADVANCED");
if(a){
a.setEnabled(e);
if(!e){
this.setValue("ADVANCED",false)
}}
ZmImportExportBaseView.prototype.update.apply(this,arguments)
};
ZmExportView.prototype._folder_onclick=function(){
var e=this.getValue("FOLDER")=="all";
var t=e?ZmImportExportController.TYPE_TGZ:null;
t=t||this._getTypeFromFolder(appCtxt.getById(this._folderId));
this.setValue("TYPE",t);
this._initSubType(t);
this.update()
};
ZmExportView.prototype._dateFieldChangeListener=function(e,a){
var s=e?"startDateField":"endDateField";
var t=e?"startMiniCal":"endMiniCal";
var n=this.getControl(t);
var o=AjxDateUtil.simpleParseDateStr(this.getValue(s));
if(isNaN(o)){
o=n.getDate()||new Date();
this.setValue(s,AjxDateUtil.simpleComputeDateStr(o))
}else{
if(o){
n.setDate(o)
}else{
this.setValue(s,null)
}}};
ZmExportView.prototype._dateCalSelectionListener=function(t,o){
var n=AjxDateUtil.simpleParseDateStr(this.getValue("startDateField"));
var a=AjxDateUtil.simpleParseDateStr(this.getValue("endDateField"));
var e=AjxDateUtil.simpleComputeDateStr(o.detail);
if(t){
if(a&&(a.valueOf()<o.detail.valueOf())){
this.setValue("endDateField",e)
}
this.setValue("startDateField",e)
}else{
if(n&&(n.valueOf()>o.detail.valueOf())){
this.setValue("startDateField",e)
}
this.setValue("endDateField",e)
}}
}
if(AjxPackage.define("zimbraMail.share.view.ZmImportView")){
ZmImportView=function(a){
if(arguments.length==0){
return
}
a.form={
items:[{
id:"TYPE",type:"DwtRadioButtonGroup",value:ZmImportExportController.TYPE_TGZ,items:[{
id:"TYPE_TGZ",label:ZmMsg.importExportTypeTGZ,value:ZmImportExportController.TYPE_TGZ}
,{
id:"TYPE_ICS",label:ZmMsg.importExportTypeICS,value:ZmImportExportController.TYPE_ICS}
,{
id:"TYPE_CSV",label:ZmMsg.importExportTypeCSV,value:ZmImportExportController.TYPE_CSV}
],onclick:this._type_onclick}
,{
id:"TYPE_HINT",type:"DwtText"}
,{
id:"SUBTYPE",type:"DwtSelect",visible:"get('TYPE') == ZmImportExportController.TYPE_CSV && String(get('FILE')).match(/\\.csv$/i)"}
,{
id:"FOLDER_BUTTON",type:"DwtButton",label:ZmMsg.browse,enabled:"get('FILE')",onclick:this._folderButton_onclick}
,{
id:"FORM"}
,{
id:"FILE",setter:new Function()}
,{
id:"RESOLVE",type:"DwtRadioButtonGroup",value:"ignore",items:[{
id:"RESOLVE_IGNORE",label:ZmMsg.resolveDuplicateIgnore,value:"ignore"}
,{
id:"RESOLVE_MODIFY",label:ZmMsg.resolveDuplicateModify,value:"modify"}
,{
id:"RESOLVE_REPLACE",label:ZmMsg.resolveDuplicateReplace,value:"replace"}
,{
id:"RESOLVE_RESET",label:ZmMsg.resolveDuplicateReset,value:"reset"}
],visible:"get('FILE') && get('TYPE') == ZmImportExportController.TYPE_TGZ"}
,{
id:"ADVANCED",type:"DwtCheckbox",label:ZmMsg.advancedSettings,visible:"get('FILE') && get('TYPE') == ZmImportExportController.TYPE_TGZ"}
,{
id:"DATA_TYPES",type:"ZmImportExportDataTypes",visible:"get('ADVANCED')"}
]};
a.id="ZmImportView";
ZmImportExportBaseView.call(this,a);
var t=this.getControl("FORM");
var e=t&&t.elements.file;
if(e){
e.onchange=AjxCallback.simpleClosure(this._handleFileChange,this,e)
}};
ZmImportView.prototype=new ZmImportExportBaseView;
ZmImportView.prototype.constructor=ZmImportView;
ZmImportView.prototype.toString=function(){
return"ZmImportView"
};
ZmImportView.prototype.TYPE_HINTS={};
ZmImportView.prototype.TYPE_HINTS[ZmImportExportController.TYPE_CSV]=ZmMsg.importFromCSVHint;
ZmImportView.prototype.TYPE_HINTS[ZmImportExportController.TYPE_ICS]=ZmMsg.importFromICSHint;
ZmImportView.prototype.TYPE_HINTS[ZmImportExportController.TYPE_TGZ]=ZmMsg.importFromTGZHint;
ZmImportView.prototype.TEMPLATE="data.ImportExport#ImportView";
ZmImportView.prototype.getParams=function(){
var n=this.getControl("FORM");
var t=n&&n.elements.file.value;
var o=t&&t.replace(/^.*\./,"").toLowerCase();
var a=o||this.getValue("TYPE")||ZmImportExportController.TYPE_TGZ;
var e=a==ZmImportExportController.TYPE_TGZ;
var s={
form:n,type:a,subType:this.isRelevant("SUBTYPE")?this.getValue("SUBTYPE"):null,views:this.isRelevant("DATA_TYPES")?this.getValue("DATA_TYPES"):null,resolve:this.isRelevant("RESOLVE")&&e?this.getValue("RESOLVE"):null,folderId:this._folderId,dataTypes:this.isRelevant("DATA_TYPES")?this.getValue("DATA_TYPES"):null};
if(s.resolve=="ignore"){
delete s.resolve
}
return s
};
ZmImportView.prototype._getSubTypeOptions=function(t){
var e=ZmImportExportBaseView.prototype._getSubTypeOptions.apply(this,arguments);
if(t==ZmImportExportController.TYPE_CSV){
e=[].concat({
displayValue:ZmMsg.importAutoDetect,value:""}
,e)
}
return e
};
ZmImportView.prototype._handleFileChange=function(t){
var e=t.value;
var o=e.replace(/^.*\./,"").toLowerCase();
var a=ZmImportExportController.EXTS_TYPE[o];
if(a){
this.set("TYPE",a)
}}
}
if(AjxPackage.define("zimbraMail.prefs.view.ZmImportExportPage")){
ZmImportExportPage=function(t,a,e){
ZmPreferencesPage.apply(this,arguments)
};
ZmImportExportPage.prototype=new ZmPreferencesPage;
ZmImportExportPage.prototype.constructor=ZmImportExportPage;
ZmImportExportPage.prototype.toString=function(){
return"ZmImportExportPage"
};
ZmImportExportPage.prototype.reset=function(t){
ZmPreferencesPage.prototype.reset.apply(this,arguments);
var e=this.getFormObject("IMPORT_BUTTON");
if(e){
e.setEnabled(true)
}};
ZmImportExportPage.prototype._setupCustom=function(n,e,o){
if(n=="EXPORT_FOLDER"){
var t=new ZmExportView({
parent:this}
);
this.setFormObject(n,t);
return t
}
if(n=="EXPORT_BUTTON"){
var a=new DwtButton({
parent:this,id:n}
);
a.setText(e.displayName);
a.addSelectionListener(new AjxListener(this,this._handleExportButton));
this.setFormObject(n,a);
return a
}
if(n=="IMPORT_FOLDER"){
var t=new ZmImportView({
parent:this}
);
this.setFormObject(n,t);
return t
}
if(n=="IMPORT_BUTTON"){
var a=new DwtButton({
parent:this,id:n}
);
a.setText(e.displayName);
a.addSelectionListener(new AjxListener(this,this._handleImportButton));
this.setFormObject(n,a);
return a
}
return ZmPreferencesPage.prototype._setupCustom.apply(this,arguments)
};
ZmImportExportPage.prototype._handleImportButton=function(){
var t=this.getFormObject("IMPORT_BUTTON");
if(t){
t.setEnabled(false)
}
var a=this.getFormObject("IMPORT_FOLDER");
var o={};
o=a&&a.getParams();
o.callback=o.errorCallback=new AjxCallback(this,this._handleImportComplete);
var e=appCtxt.getImportExportController();
if(e.importData(o)){
var o={
msg:ZmMsg.importStarted,level:ZmStatusView.LEVEL_INFO};
appCtxt.setStatusMsg(o)
}else{
if(t){
t.setEnabled(true)
}}};
ZmImportExportPage.prototype._handleExportButton=function(){
var t=this.getFormObject("EXPORT_FOLDER");
var a=t.getParams();
var e=appCtxt.getImportExportController();
e.exportData(a)
};
ZmImportExportPage.prototype._handleImportComplete=function(){
var e=this.getFormObject("IMPORT_BUTTON");
if(e){
e.setEnabled(true)
}}
}}
if(AjxPackage.define("data.ImportExport")){
AjxTemplate.register("data.ImportExport#ImportExportPrefPage",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<!-- revert not used -- just to keep spacing consistent --><div align=right style='margin-right: 20px; margin-bottom: 10px;'><!-- div id='";
e[a++]=n.id;
e[a++]="_REVERT_PAGE' tabindex='10' style='margin-right: 25px;'></div --></div>";
if(appCtxt.get(ZmSetting.IMPORT_ENABLED)){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg._import;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"><tr><td><div id='";
e[a++]=n.id;
e[a++]='_IMPORT_FOLDER\' tabindex="100"></div></td></tr><tr><td><table align="right"><tr><td><button id="';
e[a++]=n.id;
e[a++]='_IMPORT_BUTTON" tabindex="200"></button></td></tr></table></td></tr></table></td></tr></table>'
}
if(appCtxt.get(ZmSetting.EXPORT_ENABLED)){
e[a++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr class='ZOptionsHeaderRow'><td class='ZOptionsHeaderL'><div class='ImgPrefsHeader_L'></div></td><td class='ZOptionsHeader ImgPrefsHeader'>";
e[a++]=ZmMsg._export;
e[a++]="</td><td class='ZOptionsHeaderR'><div class='ImgPrefsHeader_R'></div></td></tr></table><table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=0 width=100%><tr><td class='ZOptionsSectionMain'><table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"><tr><td><div id='";
e[a++]=n.id;
e[a++]='_EXPORT_FOLDER\' tabindex="300"></div></td></tr><tr><td><table align="right"><tr><td><button id="';
e[a++]=n.id;
e[a++]='_EXPORT_BUTTON" tabindex="400"></button></td></tr></table></td></tr></table></td></tr></table>'
}
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#ImportExportPrefPage"}
,false);
AjxTemplate.register("data.ImportExport",AjxTemplate.getTemplate("data.ImportExport#ImportExportPrefPage"),AjxTemplate.getParams("data.ImportExport#ImportExportPrefPage"));
AjxTemplate.register("data.ImportExport#ImportView",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=2 width=100%><tr><td class=\"ZOptionsLabelTop\">";
e[a++]=ZmMsg.fileLabel;
e[a++]='</td><td class="ZOptionsField" style=\'padding-left:0.5em;\'><form id="';
e[a++]=n.id;
e[a++]='_FORM" method="POST" enctype="multipart/form-data"><input id="';
e[a++]=n.id;
e[a++]='_FILE" name="file" type="file" tabindex="100"></form></td></tr><tr id=\'';
e[a++]=n.id;
e[a++]='_SUBTYPE_row\'><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.typeLabel;
e[a++]='</td><td><select id="';
e[a++]=n.id;
e[a++]='_SUBTYPE" tabindex="200"></select></td></tr><tr id="';
e[a++]=n.id;
e[a++]='_FOLDER_row"><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.destinationLabel;
e[a++]='</td><td class="ZOptionsField"><table border="0" cellpadding="0" cellspacing="0"><tr><td><button id="';
e[a++]=n.id;
e[a++]='_FOLDER_BUTTON" tabindex="300"></button></td></tr></table></td></tr><tr id=\'';
e[a++]=n.id;
e[a++]='_RESOLVE_row\'><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.resolveDuplicatesLabel;
e[a++]='</td><td class="ZOptionsField"><table border="0" cellpadding="0" cellspacing="0"><tr><td><div id="';
e[a++]=n.id;
e[a++]='_RESOLVE_IGNORE" tabindex="500"></div></td><td><div id="';
e[a++]=n.id;
e[a++]='_RESOLVE_MODIFY" tabindex="501"></div></td><td><div id="';
e[a++]=n.id;
e[a++]='_RESOLVE_REPLACE" tabindex="502"></div></td><td><div id="';
e[a++]=n.id;
e[a++]='_RESOLVE_RESET" tabindex="503"></div></td></tr></table></td></tr><tr id="';
e[a++]=n.id;
e[a++]='_ADVANCED_row"><td class="ZOptionsLabelTop">&nbsp;</td><td class="ZOptionsField"><hr><span id="';
e[a++]=n.id;
e[a++]='_ADVANCED" tabindex="700"></span></td></tr><tr id="';
e[a++]=n.id;
e[a++]='_DATA_TYPES_row"><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.dataTypesLabel;
e[a++]='</td><td class="ZOptionsField" style="padding-top: 5px;"><div>';
e[a++]=ZmMsg.dataTypesHint;
e[a++]='</div><div id="';
e[a++]=n.id;
e[a++]='_DATA_TYPES" tabindex="800"></div></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#ImportView","class":"ZmImportView"}
,false);
AjxTemplate.register("data.ImportExport#ExportView",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table class='ZOptionsSectionTable' border=0 cellspacing=0 cellpadding=2 width=100%>";
if(appCtxt.get(ZmSetting.CALENDAR_ENABLED)||appCtxt.get(ZmSetting.CONTACTS_ENABLED)){
e[a++]='<tr><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.typeLabel;
e[a++]='</td><td class="ZOptionsField"><table border="0" cellpadding="0" cellspacing="0"><tr><td><table border="0" cellpadding="0" cellspacing="0"><tr><td><div id="';
e[a++]=n.id;
e[a++]='_TYPE_TGZ" tabindex="100"></div></td>';
if(appCtxt.get(ZmSetting.CALENDAR_ENABLED)){
e[a++]='<td><div id="';
e[a++]=n.id;
e[a++]='_TYPE_ICS" tabindex="101"></div></td>'
}
if(appCtxt.get(ZmSetting.CONTACTS_ENABLED)){
e[a++]='<td><div id="';
e[a++]=n.id;
e[a++]='_TYPE_CSV" tabindex="102"></div></td>'
}
e[a++]='</tr></table></td><td><select id="';
e[a++]=n.id;
e[a++]='_SUBTYPE" tabindex="200"></select></td></tr></table><div id="';
e[a++]=n.id;
e[a++]='_TYPE_HINT" class="ZOptionsInfo"></div></td></tr>'
}
e[a++]='<tr><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.sourceLabel;
e[a++]='</td><td class="ZOptionsField"><table border="0" cellpadding="0" cellspacing="0"><tr><td><button id="';
e[a++]=n.id;
e[a++]='_FOLDER_BUTTON" tabindex="300"></button></td></tr></table>';
if(appCtxt.get(ZmSetting.OFFLINE_ENABLED)){
e[a++]='<div id="';
e[a++]=n.id;
e[a++]='_IGNORE_ARCHIVE" tabindex="400"></div>'
}
e[a++]='</td></tr><tr id="';
e[a++]=n.id;
e[a++]='_ADVANCED_row"><td class="ZOptionsLabelTop">&nbsp;</td><td class="ZOptionsField"><hr><span id="';
e[a++]=n.id;
e[a++]='_ADVANCED" tabindex="500"></span></td></tr><tr id="';
e[a++]=n.id;
e[a++]='_DATA_TYPES_row"><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.dataTypesLabel;
e[a++]='</td><td class="ZOptionsField" style="padding-top: 5px;"><div>';
e[a++]=ZmMsg.dataTypesHint;
e[a++]='</div><div id="';
e[a++]=n.id;
e[a++]='_DATA_TYPES" tabindex="600"></div></td></tr><tr id="';
e[a++]=n.id;
e[a++]='_DATE_row"><td class="ZOptionsLabelTop">';
e[a++]=ZmMsg.date;
e[a++]=":</td>";
e[a++]=AjxTemplate.expand("#DatePickers",n);
e[a++]='</tr><tr id="';
e[a++]=n.id;
e[a++]='_SEARCH_FILTER_row"><td class="ZOptionsLabelTop" style="width:inherit;">';
e[a++]=ZmMsg.searchFilterLabel;
e[a++]='</td><td class="ZOptionsField"><input id="';
e[a++]=n.id;
e[a++]='_SEARCH_FILTER" length="40" hint="';
e[a++]=ZmMsg.searchFilterHint;
e[a++]='" tabindex="700" size="40"></td></tr><tr id="';
e[a++]=n.id;
e[a++]='_SKIP_META_row"><td class="ZOptionsLabelTop" style="width:inherit;">';
e[a++]=ZmMsg.otherLabel;
e[a++]='</td><td class="ZOptionsField"><span id="';
e[a++]=n.id;
e[a++]='_SKIP_META" tabindex="800"></span></td></tr></table>';
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#ExportView","class":"ZmExportView"}
,false);
AjxTemplate.register("data.ImportExport#DataTypes",function(e,t,r,n){
var a=Boolean(n);
r=(typeof r=="string"?{
id:r}
:r)||{};
n=n||[];
var o=n.length;
n[o++]='<table border="0" cellpadding="0" cellspacing="4">';
var h=r.count;
var l=h/3;
for(var s=0;
s<h;
s++){
if((s%3)==0){
n[o++]="<tr>"
}
n[o++]='<td><span id="';
n[o++]=r.id;
n[o++]="_cell_";
n[o++]=s;
n[o++]='"></span></td>'
}
n[o++]="</table>";
return a?n.length:n.join("")
}
,{
id:"data.ImportExport#DataTypes"}
,false);
AjxTemplate.register("data.ImportExport#DataTypeCheckbox",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<table cellpadding='2' cellspacing='0' border='0'><tr><td><input id='";
e[a++]=n.id;
e[a++]="_input' name='";
e[a++]=n.name;
e[a++]="' value='";
e[a++]=n.value;
e[a++]="' type='checkbox' ";
e[a++]=n.checked;
e[a++]="></td><td><div id='";
e[a++]=n.id;
e[a++]="_image'></div></td><td><label for='";
e[a++]=n.id;
e[a++]="_input' id='";
e[a++]=n.id;
e[a++]="_text_right' class='Text' style='text-align:left'></label></td></tr></table>";
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#DataTypeCheckbox"}
,false);
AjxTemplate.register("data.ImportExport#DateField",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<td><input autocomplete='off' style='height:22px;' type='text' size=14 id='";
e[a++]=n.id;
e[a++]="' value='";
e[a++]=n.value;
e[a++]="'></td>";
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#DateField"}
,false);
AjxTemplate.register("data.ImportExport#DatePickers",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]="<td><table border=0 cellpadding=0 cellspacing=0>";
e[a++]=AjxTemplate.expand("#StartDate",n);
e[a++]="\n";
e[a++]="\t\t&nbsp;\n";
e[a++]="\t\t";
e[a++]=AjxTemplate.expand("#EndDate",n);
e[a++]="</table></td>";
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#DatePickers"}
,false);
AjxTemplate.register("data.ImportExport#StartDate",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<td class="quickAddDateFld">';
e[a++]=ZmMsg.startOn;
e[a++]="&nbsp;";
e[a++]=AjxTemplate.expand("#DateField",{
id:n.id+"_startDateField"}
);
e[a++]="</td><td><div id='";
e[a++]=n.id;
e[a++]="_startMiniCalBtn'/></td>";
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#StartDate"}
,false);
AjxTemplate.register("data.ImportExport#EndDate",function(t,s,n,e){
var o=Boolean(e);
n=(typeof n=="string"?{
id:n}
:n)||{};
e=e||[];
var a=e.length;
e[a++]='<td class="quickAddDateFld">';
e[a++]=ZmMsg.endOn;
e[a++]="&nbsp;";
e[a++]=AjxTemplate.expand("#DateField",{
id:n.id+"_endDateField"}
);
e[a++]="</td><td><div id='";
e[a++]=n.id;
e[a++]="_endMiniCalBtn'/></td>";
return o?e.length:e.join("")
}
,{
id:"data.ImportExport#EndDate"}
,false)
};
