
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxFormat=function(e){
if(arguments.length==0){
return
}
this._pattern=e;
this._segments=[]
};
AjxFormat.prototype.toString=function(){
var t=[];
t.push('pattern="',this._pattern,'"');
if(this._segments.length>0){
t.push(", segments={ ");
for(var e=0;
e<this._segments.length;
e++){
if(e>0){
t.push(", ")
}
t.push(String(this._segments[e]))
}
t.push(" }")
}
return t.join("")
};
AjxFormat.prototype._pattern;
AjxFormat.prototype._segments;
AjxFormat.initialize=function(){
AjxDateFormat.initialize();
AjxNumberFormat.initialize()
};
AjxFormat.prototype.format=function(e){
var a=[];
for(var t=0;
t<this._segments.length;
t++){
a.push(this._segments[t].format(e))
}
return a.join("")
};
AjxFormat.prototype.parse=function(o){
var t=this._createParseObject();
var e=0;
for(var a=0;
a<this._segments.length;
a++){
var n=this._segments[a];
e=n.parse(t,o,e)
}
if(e<o.length){
throw new AjxFormat.ParsingException(this,null,"input too long")
}
return t
};
AjxFormat.prototype.getSegments=function(){
return this._segments
};
AjxFormat.prototype.toPattern=function(){
return this._pattern
};
AjxFormat.prototype.clone=function(){
return new this.constructor(this._pattern)
};
AjxFormat.prototype._createParseObject=function(e){
throw new AjxFormat.ParsingException(this,null,"not implemented")
};
AjxFormat._zeroPad=function(n,r,t,h){
n=typeof n=="string"?n:String(n);
if(n.length>=r){
return n
}
t=t||"0";
var e=[];
for(var o=n.length;
o<r;
o++){
e.push(t)
}
e[h?"unshift":"push"](n);
return e.join("")
};
AjxFormat.FormatException=function(t,e){
this._format=t;
this._message=e
};
AjxFormat.FormatException.prototype.toString=function(){
return this._message
};
AjxFormat.FormatException.prototype._format;
AjxFormat.FormatException.prototype._message;
AjxFormat.FormattingException=function(a,t,e){
AjxFormat.FormatException.call(this,a,e);
this._segment=t
};
AjxFormat.FormattingException.prototype=new AjxFormat.FormatException;
AjxFormat.FormattingException.prototype.constructor=AjxFormat.FormattingException;
AjxFormat.FormattingException.prototype._segment;
AjxFormat.ParsingException=function(a,t,e){
AjxFormat.FormatException.call(this,a,e);
this._segment=t
};
AjxFormat.ParsingException.prototype=new AjxFormat.FormatException;
AjxFormat.ParsingException.prototype.constructor=AjxFormat.ParsingException;
AjxFormat.ParsingException.prototype._segment;
AjxFormat.Segment=function(t,e){
if(arguments.length==0){
return
}
this._parent=t;
this._s=e
};
AjxFormat.Segment.prototype.toString=function(){
return'segment: "'+this._s+'"'
};
AjxFormat.Segment.prototype._parent;
AjxFormat.Segment.prototype._s;
AjxFormat.Segment.prototype.format=function(e){
return this._s
};
AjxFormat.Segment.prototype.parse=function(a,t,e){
throw new AjxFormat.ParsingException(this._parent,this,"not implemented")
};
AjxFormat.Segment.prototype.getFormat=function(){
return this._parent
};
AjxFormat.Segment.prototype.toSubPattern=function(){
return this._s
};
AjxFormat.Segment.prototype._getFixedLength=function(){
var e;
if(this._index+1<this._parent._segments.length){
var t=this._parent._segments[this._index+1];
if(!(t instanceof AjxFormat.TextSegment)){
e=this._s.length
}}
return e
};
AjxFormat.Segment._parseLiteral=function(o,a,e){
if(a.length-e<o.length){
throw new AjxFormat.ParsingException(this._parent,this,"input too short")
}
for(var t=0;
t<o.length;
t++){
if(o.charAt(t)!=a.charAt(e+t)){
throw new AjxFormat.ParsingException(this._parent,this,"input doesn't match")
}}
return e+o.length
};
AjxFormat.Segment._parseLiterals=function(a,h,u,t,p,l){
for(var r=0;
r<t.length;
r++){
try{
var m=t[r];
var n=AjxFormat.Segment._parseLiteral(m,p,l);
if(h){
var d=a||window;
if(typeof h=="function"){
h.call(d,r+u)
}else{
d[h]=r+u
}}
return n
}
catch(c){}}
return -1
};
AjxFormat.Segment._parseInt=function(t,n,p,g,r,e,u){
var h=e||g.length-r;
var d=r;
for(var a=0;
a<h;
a++){
if(!g.charAt(r++).match(/\d/)){
r--;
break
}}
var c=r;
if(d==c){
throw new AjxFormat.ParsingException(this._parent,this,"number not present")
}
if(e&&c-d!=e){
throw new AjxFormat.ParsingException(this._parent,this,"number too short")
}
var m=parseInt(g.substring(d,c),u||10);
if(n){
var l=t||window;
if(typeof n=="function"){
n.call(l,m+p)
}else{
l[n]=m+p
}}
return c
};
AjxDateFormat=function(s){
if(arguments.length==0){
return
}
AjxFormat.call(this,s);
if(s==null){
return
}
if(typeof s=="number"){
switch(s){
case AjxDateFormat.SHORT:s=I18nMsg.formatDateShort;
break;
case AjxDateFormat.MEDIUM:s=I18nMsg.formatDateMedium;
break;
case AjxDateFormat.LONG:s=I18nMsg.formatDateLong;
break;
case AjxDateFormat.FULL:s=I18nMsg.formatDateFull;
break;
case AjxDateFormat.SEARCH:s=I18nMsg.formatDateSearch;
break
}}
for(var a=0;
a<s.length;
a++){
var h=s.charAt(a);
if(h=="'"){
var t=a+1;
for(a++;
a<s.length;
a++){
var h=s.charAt(a);
if(h=="'"){
if(a+1<s.length&&s.charAt(a+1)=="'"){
s=s.substr(0,a)+s.substr(a+1)
}else{
break
}}}
if(a==s.length){}
var e=a;
var n=new AjxFormat.TextSegment(this,s.substring(t,e));
this._segments.push(n);
continue
}
var t=a;
while(a<s.length){
h=s.charAt(a);
if(AjxDateFormat._META_CHARS.indexOf(h)!=-1||h=="'"){
break
}
a++
}
var e=a;
if(t!=e){
var n=new AjxFormat.TextSegment(this,s.substring(t,e));
this._segments.push(n);
a--;
continue
}
var t=a;
while(++a<s.length){
if(s.charAt(a)!=h){
break
}}
var e=a--;
var o=e-t;
var r=s.substr(t,o);
var n=null;
switch(h){
case"G":n=new AjxDateFormat.EraSegment(this,r);
break;
case"y":n=new AjxDateFormat.YearSegment(this,r);
break;
case"M":n=new AjxDateFormat.MonthSegment(this,r);
break;
case"w":n=new AjxDateFormat.WeekSegment(this,r);
break;
case"W":n=new AjxDateFormat.WeekSegment(this,r);
break;
case"D":n=new AjxDateFormat.DaySegment(this,r);
break;
case"d":n=new AjxDateFormat.DaySegment(this,r);
break;
case"F":n=new AjxDateFormat.WeekdaySegment(this,r);
break;
case"E":n=new AjxDateFormat.WeekdaySegment(this,r);
break;
case"a":n=new AjxDateFormat.AmPmSegment(this,r);
break;
case"H":n=new AjxDateFormat.HourSegment(this,r);
break;
case"k":n=new AjxDateFormat.HourSegment(this,r);
break;
case"K":n=new AjxDateFormat.HourSegment(this,r);
break;
case"h":n=new AjxDateFormat.HourSegment(this,r);
break;
case"m":n=new AjxDateFormat.MinuteSegment(this,r);
break;
case"s":n=new AjxDateFormat.SecondSegment(this,r);
break;
case"S":n=new AjxDateFormat.SecondSegment(this,r);
break;
case"z":n=new AjxDateFormat.TimezoneSegment(this,r);
break;
case"Z":n=new AjxDateFormat.TimezoneSegment(this,r);
break
}
if(n!=null){
n._index=this._segments.length;
this._segments.push(n)
}}};
AjxDateFormat.prototype=new AjxFormat;
AjxDateFormat.prototype.constructor=AjxDateFormat;
AjxDateFormat.prototype.toString=function(){
return"[AjxDateFormat: "+AjxFormat.prototype.toString.call(this)+"]"
};
AjxDateFormat.SHORT=0;
AjxDateFormat.MEDIUM=1;
AjxDateFormat.LONG=2;
AjxDateFormat.FULL=3;
AjxDateFormat.DEFAULT=AjxDateFormat.MEDIUM;
AjxDateFormat.SEARCH=4;
AjxDateFormat._META_CHARS="GyMwWDdFEaHkKhmsSzZ";
AjxDateFormat.getDateInstance=function(e){
e=e!=null?e:AjxDateFormat.DEFAULT;
if(!AjxDateFormat._DATE_FORMATTERS[e]){
AjxDateFormat._DATE_FORMATTERS[e]=new AjxDateFormat(AjxDateFormat._dateFormats[e])
}
return AjxDateFormat._DATE_FORMATTERS[e]
};
AjxDateFormat.getTimeInstance=function(e){
e=e!=null?e:AjxDateFormat.DEFAULT;
if(!AjxDateFormat._TIME_FORMATTERS[e]){
AjxDateFormat._TIME_FORMATTERS[e]=new AjxDateFormat(AjxDateFormat._timeFormats[e])
}
return AjxDateFormat._TIME_FORMATTERS[e]
};
AjxDateFormat.getDateTimeInstance=function(e,t){
e=e!=null?e:AjxDateFormat.DEFAULT;
t=t!=null?t:AjxDateFormat.DEFAULT;
var i=e*10+t;
if(!AjxDateFormat._DATETIME_FORMATTERS[i]){
var o=I18nMsg.formatDateTime;
var n=[AjxDateFormat._dateFormats[e],AjxDateFormat._timeFormats[t]];
var a=AjxMessageFormat.format(o,n);
AjxDateFormat._DATETIME_FORMATTERS[i]=new AjxDateFormat(a)
}
return AjxDateFormat._DATETIME_FORMATTERS[i]
};
AjxDateFormat.format=function(t,e){
return new AjxDateFormat(t).format(e)
};
AjxDateFormat.parse=function(t,e){
return new AjxDateFormat(t).parse(e)
};
AjxDateFormat.initialize=function(){
AjxDateFormat._dateFormats=[I18nMsg.formatDateShort,I18nMsg.formatDateMedium,I18nMsg.formatDateLong,I18nMsg.formatDateFull,I18nMsg.formatDateSearch];
AjxDateFormat._timeFormats=[I18nMsg.formatTimeShort,I18nMsg.formatTimeMedium,I18nMsg.formatTimeLong,I18nMsg.formatTimeFull];
AjxDateFormat._timeParsers=[];
for(var t=1,e;
e=I18nMsg["parseTime"+t];
t++){
AjxDateFormat._timeParsers.push(new RegExp(e,"i"))
}
AjxDateFormat._DATE_FORMATTERS={};
AjxDateFormat._TIME_FORMATTERS={};
AjxDateFormat._DATETIME_FORMATTERS={};
AjxDateFormat.MonthSegment.initialize();
AjxDateFormat.WeekdaySegment.initialize()
};
AjxDateFormat.parseTime=function(r){
for(var s=0;
s<AjxDateFormat._timeParsers.length;
s++){
var e=AjxDateFormat._timeParsers[s].exec(r);
if(e){
var a=parseInt(e[1],10)||0;
var n=parseInt(e[2],10)||0;
var o=e[3];
if(o){
var t=I18nMsg.parseTimePMChars;
if(a==12){
a=0
}
if(t.indexOf(o)!=-1){
a+=12
}}
if(a<24&&n<60){
date=new Date();
date.setHours(a);
date.setMinutes(n);
date.setSeconds(0);
return date
}}}};
AjxDateFormat.prototype.parse=function(o){
var i=null;
try{
i=AjxFormat.prototype.parse.call(this,o);
var a=new Date(0,0,1,0,0,0,0);
if(i.year!=null){
a.setFullYear(i.year)
}
if(i.month!=null){
a.setMonth(i.month)
}
if(i.dayofmonth!=null){
a.setDate(i.dayofmonth)
}else{
if(i.dayofyear!=null){
a.setMonth(0,i.dayofyear)
}}
if(i.hours!=null){
a.setHours(i.hours)
}
if(i.minutes!=null){
a.setMinutes(i.minutes)
}
if(i.seconds!=null){
a.setSeconds(i.seconds)
}
if(i.milliseconds!=null){
a.setMilliseconds(i.milliseconds)
}
if(i.ampm!=null){
var t=a.getHours();
if(t==12&&i.ampm==0){
t=0
}else{
if(t!=12&&i.ampm==1){
t+=12
}}
a.setHours(t)
}
if(i.timezone!=null){
a.setMinutes(a.getMinutes()-i.timezone)
}
if(isNaN(a.getTime())){
return null
}
i=a
}
catch(n){}
return i
};
AjxDateFormat.prototype._createParseObject=function(){
return{
year:null,month:null,dayofmonth:null,dayofyear:null,hours:null,minutes:null,seconds:null,milliseconds:null,ampm:null,era:null,timezone:null}
};
AjxFormat.TextSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxFormat.TextSegment.prototype=new AjxFormat.Segment;
AjxFormat.TextSegment.prototype.constructor=AjxFormat.TextSegment;
AjxFormat.TextSegment.prototype.toString=function(){
return'text: "'+this._s+'"'
};
AjxFormat.TextSegment.prototype.parse=function(a,t,e){
return AjxFormat.Segment._parseLiteral(this._s,t,e)
};
AjxDateFormat.DateSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.DateSegment.prototype=new AjxFormat.Segment;
AjxDateFormat.DateSegment.prototype.constructor=AjxDateFormat.DateSegment;
AjxDateFormat.EraSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.EraSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.EraSegment.prototype.constructor=AjxDateFormat.EraSegment;
AjxDateFormat.EraSegment.prototype.toString=function(){
return'dateEra: "'+this._s+'"'
};
AjxDateFormat.EraSegment.prototype.format=function(e){
return I18nMsg.eraAD
};
AjxDateFormat.YearSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.YearSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.YearSegment.prototype.constructor=AjxDateFormat.YearSegment;
AjxDateFormat.YearSegment.prototype.toString=function(){
return'dateYear: "'+this._s+'"'
};
AjxDateFormat.YearSegment.prototype.format=function(e){
var t=String(e.getFullYear());
return this._s.length<4?t.substr(t.length-2):AjxFormat._zeroPad(t,this._s.length)
};
AjxDateFormat.YearSegment.prototype.parse=function(a,l,o){
var e=this._getFixedLength();
var t=AjxFormat.Segment._parseInt(a,"year",0,l,o,e);
if(t-o==2){
if(!AjxDateFormat._2digitStartYear){
AjxDateFormat._2digitStartYear=parseInt(AjxMsg.dateParsing2DigitStartYear)
}
var r=AjxDateFormat._2digitStartYear;
var h=parseInt(l.substr(o,2),10);
var i=(Math.floor(r/100)+(h<(r%100)?1:0))*100;
var n=i+h;
a.year=n
}
return t
};
AjxDateFormat.MonthSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.MonthSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.MonthSegment.prototype.constructor=AjxDateFormat.MonthSegment;
AjxDateFormat.MonthSegment.prototype.toString=function(){
return'dateMonth: "'+this._s+'"'
};
AjxDateFormat.MonthSegment.initialize=function(){
AjxDateFormat.MonthSegment.MONTHS={};
AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT]=[AjxMsg.monthJanShort,AjxMsg.monthFebShort,AjxMsg.monthMarShort,AjxMsg.monthAprShort,AjxMsg.monthMayShort,AjxMsg.monthJunShort,AjxMsg.monthJulShort,AjxMsg.monthAugShort,AjxMsg.monthSepShort,AjxMsg.monthOctShort,AjxMsg.monthNovShort,AjxMsg.monthDecShort];
AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM]=[I18nMsg.monthJanMedium,I18nMsg.monthFebMedium,I18nMsg.monthMarMedium,I18nMsg.monthAprMedium,I18nMsg.monthMayMedium,I18nMsg.monthJunMedium,I18nMsg.monthJulMedium,I18nMsg.monthAugMedium,I18nMsg.monthSepMedium,I18nMsg.monthOctMedium,I18nMsg.monthNovMedium,I18nMsg.monthDecMedium];
AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG]=[I18nMsg.monthJanLong,I18nMsg.monthFebLong,I18nMsg.monthMarLong,I18nMsg.monthAprLong,I18nMsg.monthMayLong,I18nMsg.monthJunLong,I18nMsg.monthJulLong,I18nMsg.monthAugLong,I18nMsg.monthSepLong,I18nMsg.monthOctLong,I18nMsg.monthNovLong,I18nMsg.monthDecLong]
};
AjxDateFormat.MonthSegment.prototype.format=function(e){
var t=e.getMonth();
switch(this._s.length){
case 1:return String(t+1);
case 2:return AjxFormat._zeroPad(t+1,2);
case 3:return AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM][t];
case 5:return AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT][t]
}
return AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG][t]
};
AjxDateFormat.MonthSegment.prototype.parse=function(a,o,t){
var e;
switch(this._s.length){
case 3:e=AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM];
case 4:e=e||AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG];
case 5:e=e||AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT];
var i=AjxFormat.Segment._parseLiterals(a,"month",0,e,o,t);
if(i==-1){
throw new AjxFormat.ParsingException(this._parent,this,"no match")
}
return i
}
var n=this._getFixedLength();
return AjxFormat.Segment._parseInt(a,"month",-1,o,t,n)
};
AjxDateFormat.WeekSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.WeekSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.WeekSegment.prototype.constructor=AjxDateFormat.WeekSegment;
AjxDateFormat.WeekSegment.prototype.toString=function(){
return'weekMonth: "'+this._s+'"'
};
AjxDateFormat.WeekSegment.prototype.format=function(t){
var i=t.getYear();
var n=t.getMonth();
var e=t.getDate();
var s=/w/.test(this._s);
var o=new Date(i,s?0:n,1);
var a=0;
while(true){
a++;
if(o.getMonth()>n||(o.getMonth()==n&&o.getDate()>=e)){
break
}
o.setDate(o.getDate()+7)
}
return AjxFormat._zeroPad(a,this._s.length)
};
AjxDateFormat.WeekSegment.prototype.parse=function(t,a,e){
var i=this._getFixedLength();
return AjxFormat.Segment._parseInt(null,null,0,a,e,i)
};
AjxDateFormat.DaySegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.DaySegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.DaySegment.prototype.constructor=AjxDateFormat.DaySegment;
AjxDateFormat.DaySegment.prototype.toString=function(){
return'dateDay: "'+this._s+'"'
};
AjxDateFormat.DaySegment.prototype.format=function(t){
var o=t.getMonth();
var e=t.getDate();
if(/D/.test(this._s)&&o>0){
var a=t.getYear();
do{
var i=new Date(a,o,1);
i.setDate(0);
e+=i.getDate();
o--
}
while(o>0)
}
return AjxFormat._zeroPad(e,this._s.length)
};
AjxDateFormat.DaySegment.prototype.parse=function(t,o,e){
var n=this._getFixedLength();
var i=function(s){
if(s>AjxDateUtil.MAX_DAYS_PER_MONTH){
throw new AjxFormat.ParsingException(this._parent,this,"number too long")
}else{
t.dayofmonth=s
}};
var a=/D/.test(this._s)?"dayofyear":i;
return AjxFormat.Segment._parseInt(t,a,0,o,e,n)
};
AjxDateFormat.WeekdaySegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.WeekdaySegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.WeekdaySegment.prototype.constructor=AjxDateFormat.WeekdaySegment;
AjxDateFormat.DaySegment.prototype.toString=function(){
return'dateDay: "'+this._s+'"'
};
AjxDateFormat.WeekdaySegment.initialize=function(){
AjxDateFormat.WeekdaySegment.WEEKDAYS={};
AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.SHORT]=[AjxMsg.weekdaySunShort,AjxMsg.weekdayMonShort,AjxMsg.weekdayTueShort,AjxMsg.weekdayWedShort,AjxMsg.weekdayThuShort,AjxMsg.weekdayFriShort,AjxMsg.weekdaySatShort];
AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.MEDIUM]=[I18nMsg.weekdaySunMedium,I18nMsg.weekdayMonMedium,I18nMsg.weekdayTueMedium,I18nMsg.weekdayWedMedium,I18nMsg.weekdayThuMedium,I18nMsg.weekdayFriMedium,I18nMsg.weekdaySatMedium];
AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.LONG]=[I18nMsg.weekdaySunLong,I18nMsg.weekdayMonLong,I18nMsg.weekdayTueLong,I18nMsg.weekdayWedLong,I18nMsg.weekdayThuLong,I18nMsg.weekdayFriLong,I18nMsg.weekdaySatLong]
};
AjxDateFormat.WeekdaySegment.prototype.format=function(e){
var a=e.getDay();
if(/E/.test(this._s)){
var t;
switch(this._s.length){
case 4:t=AjxDateFormat.LONG;
break;
case 5:t=AjxDateFormat.SHORT;
break;
default:t=AjxDateFormat.MEDIUM
}
return AjxDateFormat.WeekdaySegment.WEEKDAYS[t][a]
}
return AjxFormat._zeroPad(a,this._s.length)
};
AjxDateFormat.WeekdaySegment.prototype.parse=function(a,o,t){
var e;
switch(this._s.length){
case 3:e=AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.MEDIUM];
case 4:e=e||AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.LONG];
case 5:e=e||AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.SHORT];
var i=AjxFormat.Segment._parseLiterals(null,null,0,e,o,t);
if(i==-1){
throw new AjxFormat.ParsingException(this._parent,this,"no match")
}
return i
}
var n=this._getFixedLength();
return AjxFormat.Segment._parseInt(null,null,0,o,t,n)
};
AjxDateFormat.TimeSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.TimeSegment.prototype=new AjxFormat.Segment;
AjxDateFormat.TimeSegment.prototype.constructor=AjxDateFormat.TimeSegment;
AjxDateFormat.HourSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.HourSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.HourSegment.prototype.constructor=AjxDateFormat.HourSegment;
AjxDateFormat.HourSegment.prototype.toString=function(){
return'timeHour: "'+this._s+'"'
};
AjxDateFormat.HourSegment.prototype.format=function(t){
var e=t.getHours();
if(e>12&&/[hK]/.test(this._s)){
e-=12
}else{
if(e==0&&/[h]/.test(this._s)){
e=12
}}
return AjxFormat._zeroPad(e,this._s.length)
};
AjxDateFormat.HourSegment.prototype.parse=function(t,a,e){
var i=this._getFixedLength();
return AjxFormat.Segment._parseInt(t,"hours",0,a,e,i)
};
AjxDateFormat.MinuteSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.MinuteSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.MinuteSegment.prototype.constructor=AjxDateFormat.MinuteSegment;
AjxDateFormat.MinuteSegment.prototype.toString=function(){
return'timeMinute: "'+this._s+'"'
};
AjxDateFormat.MinuteSegment.prototype.format=function(e){
var t=e.getMinutes();
return AjxFormat._zeroPad(t,this._s.length)
};
AjxDateFormat.MinuteSegment.prototype.parse=function(t,a,e){
var i=this._getFixedLength();
return AjxFormat.Segment._parseInt(t,"minutes",0,a,e,i)
};
AjxDateFormat.SecondSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.SecondSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.SecondSegment.prototype.constructor=AjxDateFormat.SecondSegment;
AjxDateFormat.SecondSegment.prototype.toString=function(){
return'timeSecond: "'+this._s+'"'
};
AjxDateFormat.SecondSegment.prototype.format=function(e){
var t=/s/.test(this._s)?e.getSeconds():e.getMilliseconds();
return AjxFormat._zeroPad(t,this._s.length)
};
AjxDateFormat.SecondSegment.prototype.parse=function(a,o,t){
var e=/s/.test(this._s);
var i=e?"seconds":"milliseconds";
var n=e?this._getFixedLength():0;
return AjxFormat.Segment._parseInt(a,i,0,o,t,n)
};
AjxDateFormat.AmPmSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.AmPmSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.AmPmSegment.prototype.constructor=AjxDateFormat.AmPmSegment;
AjxDateFormat.AmPmSegment.prototype.toString=function(){
return'timeAmPm: "'+this._s+'"'
};
AjxDateFormat.AmPmSegment.prototype.format=function(t){
var e=t.getHours();
return e<12?I18nMsg.periodAm:I18nMsg.periodPm
};
AjxDateFormat.AmPmSegment.prototype.parse=function(t,i,e){
var o=[I18nMsg.periodAm.toLowerCase(),I18nMsg.periodPm.toLowerCase(),I18nMsg.periodAm.toUpperCase(),I18nMsg.periodPm.toUpperCase()];
var a=AjxFormat.Segment._parseLiterals(t,"ampm",0,o,i,e);
if(a==-1){
throw new AjxFormat.ParsingException(this._parent,this,"no match")
}
t.ampm=t.ampm%2;
return a
};
AjxDateFormat.TimezoneSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.TimezoneSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.TimezoneSegment.prototype.constructor=AjxDateFormat.TimezoneSegment;
AjxDateFormat.TimezoneSegment.prototype.toString=function(){
return'timeTimezone: "'+this._s+'"'
};
AjxDateFormat.TimezoneSegment.prototype.format=function(t){
var e=t.timezone||AjxTimezone.DEFAULT;
if(/Z/.test(this._s)){
return AjxTimezone.getShortName(e)
}
return this._s.length<4?AjxTimezone.getMediumName(e):AjxTimezone.getLongName(e)
};
AjxMessageFormat=function(s){
if(arguments.length==0){
return
}
AjxFormat.call(this,s);
if(s==null){
return
}
for(var t=0;
t<s.length;
t++){
var r=s.charAt(t);
if(r=="'"){
if(t+1<s.length&&s.charAt(t+1)=="'"){
var a=new AjxFormat.TextSegment(this,"'");
this._segments.push(a);
t++;
continue
}
var h=t+1;
for(t++;
t<s.length;
t++){
var r=s.charAt(t);
if(r=="'"){
if(t+1<s.length&&s.charAt(t+1)=="'"){
s=s.substr(0,t)+s.substr(t+1)
}else{
break
}}}
if(t==s.length){}
var n=t;
var a=new AjxFormat.TextSegment(this,s.substring(h,n));
this._segments.push(a);
continue
}
var h=t;
while(t<s.length){
r=s.charAt(t);
if(r=="{"||r=="'"){
break
}
t++
}
var n=t;
if(h!=n){
var a=new AjxFormat.TextSegment(this,s.substring(h,n));
this._segments.push(a);
t--;
continue
}
var h=t+1;
var e=0;
while(++t<s.length){
var r=s.charAt(t);
if(r=="{"){
e++
}else{
if(r=="}"){
if(e==0){
break
}
e--
}}}
var n=t;
var o=n-h;
var l=s.substr(h,o);
var a=new AjxMessageFormat.MessageSegment(this,l);
if(a!=null){
this._segments.push(a)
}}};
AjxMessageFormat.prototype=new AjxFormat;
AjxMessageFormat.prototype.constructor=AjxMessageFormat;
AjxMessageFormat.prototype.toString=function(){
return"[AjxMessageFormat: "+AjxFormat.prototype.toString.call(this)+"]"
};
AjxMessageFormat.format=function(e,t){
return new AjxMessageFormat(e).format(t)
};
AjxMessageFormat.prototype.format=function(e){
if(!(e instanceof Array)){
e=[e]
}
return AjxFormat.prototype.format.call(this,e)
};
AjxMessageFormat.prototype.getFormats=function(){
var e=[];
for(var t=0;
t<this._segments.length;
t++){
var a=this._segments[t];
if(a instanceof AjxMessageFormat.MessageSegment){
e.push(a.getSegmentFormat())
}}
return e
};
AjxMessageFormat.prototype.getFormatsByArgumentIndex=function(){
var e=[];
for(var t=0;
t<this._segments.length;
t++){
var a=this._segments[t];
if(a instanceof AjxMessageFormat.MessageSegment){
e[a.getIndex()]=a.getSegmentFormat()
}}
return e
};
AjxMessageFormat.MessageSegment=function(i,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,i,e);
var a=AjxMessageFormat.MessageSegment._split(e,",");
this._index=Number(a[0]);
this._type=a[1]||"string";
this._style=a[2];
if(this._type=="list"){
this._isList=true;
this._type=a[2]||"string";
this._style=a[3]
}
switch(this._type){
case"number":switch(this._style){
case"integer":this._formatter=AjxNumberFormat.getIntegerInstance();
break;
case"currency":this._formatter=AjxNumberFormat.getCurrencyInstance();
break;
case"percent":this._formatter=AjxNumberFormat.getPercentInstance();
break;
default:this._formatter=this._style==null?AjxNumberFormat.getInstance():new AjxNumberFormat(this._style)
}
break;
case"date":case"time":var t=this._type=="date"?AjxDateFormat.getDateInstance:AjxDateFormat.getTimeInstance;
switch(this._style){
case"short":this._formatter=t(AjxDateFormat.SHORT);
break;
case"medium":this._formatter=t(AjxDateFormat.MEDIUM);
break;
case"long":this._formatter=t(AjxDateFormat.LONG);
break;
case"full":this._formatter=t(AjxDateFormat.FULL);
break;
default:this._formatter=this._style==null?t(AjxDateFormat.DEFAULT):new AjxDateFormat(this._style)
}
break;
case"choice":this._formatter=new AjxChoiceFormat(this._style);
break
}
if(this._isList){
this._formatter=new AjxListFormat(this._formatter)
}};
AjxMessageFormat.MessageSegment.prototype=new AjxFormat.Segment;
AjxMessageFormat.MessageSegment.prototype.constructor=AjxMessageFormat.MessageSegment;
AjxMessageFormat.MessageSegment.prototype.toString=function(){
var e=['message: "',this._s,'", index: ',this._index];
if(this._isList){
e.push(", list: ",this._isList)
}
if(this._type){
e.push(", type: ",this._type)
}
if(this._style){
e.push(", style: ",this._style)
}
if(this._formatter){
e.push(", formatter: ",this._formatter.toString())
}
return e.join("")
};
AjxMessageFormat.MessageSegment.prototype._index;
AjxMessageFormat.MessageSegment.prototype._type;
AjxMessageFormat.MessageSegment.prototype._style;
AjxMessageFormat.MessageSegment.prototype._isList=false;
AjxMessageFormat.MessageSegment.prototype._formatter;
AjxMessageFormat.MessageSegment.prototype.format=function(t){
var e=t[this._index];
if(this._formatter instanceof AjxChoiceFormat){
return this._formatter.format(t,this._index)
}
return this._formatter?this._formatter.format(e):String(e)
};
AjxMessageFormat.MessageSegment.prototype.getIndex=function(){
return this._index
};
AjxMessageFormat.MessageSegment.prototype.getType=function(){
return this._type
};
AjxMessageFormat.MessageSegment.prototype.getStyle=function(){
return this._style
};
AjxMessageFormat.MessageSegment.prototype.getSegmentFormat=function(){
return this._formatter
};
AjxMessageFormat.MessageSegment._split=function(i,e){
var o=[];
var a=0;
var t;
var n=0;
for(t=0;
t<i.length;
t++){
var r=i.charAt(t);
if(r=="{"){
n++
}else{
if(r=="}"){
n--
}else{
if(r==e&&n==0){
o.push(i.substring(a,t));
a=t+1
}}}}
if(t>a){
o.push(i.substring(a,t))
}
return o
};
AjxNumberFormat=function(g,y){
if(arguments.length==0){
return
}
AjxFormat.call(this,g);
if(!g){
return
}
var a=g.split(/;/);
var g=a[0];
var f=0;
var u=this.__parseStatic(g,f);
f=u.offset;
var s=u.text!="";
if(s){
this._segments.push(new AjxFormat.TextSegment(this,u.text))
}
var r=f;
while(f<g.length&&AjxNumberFormat._META_CHARS.indexOf(g.charAt(f))!=-1){
f++
}
var n=f;
var t=g.substring(r,n);
var b=t.indexOf("E");
var c=b!=-1?t.substring(b+1):null;
if(c){
t=t.substring(0,b);
this._showExponent=true
}
var d=t.indexOf(I18nMsg.numberSeparatorDecimal!=""?I18nMsg.numberSeparatorDecimal:".");
var w=d!=-1?t.substring(0,d):t;
if(w){
var v=w.lastIndexOf(I18nMsg.numberSeparatorGrouping!=""?I18nMsg.numberSeparatorGrouping:",");
if(v!=-1){
this._groupingOffset=w.length-v-1
}
w=w.replace(/[^#0]/g,"");
var l=w.indexOf("0");
if(l!=-1){
this._minIntDigits=w.length-l
}
this._maxIntDigits=w.length
}
var p=d!=-1?t.substring(d+1):null;
if(p){
var l=p.lastIndexOf("0");
if(l!=-1){
this._minFracDigits=l+1
}
this._maxFracDigits=p.replace(/[^#0]/g,"").length
}
this._segments.push(new AjxNumberFormat.NumberSegment(this,t));
var u=this.__parseStatic(g,f);
f=u.offset;
if(u.text!=""){
this._segments.push(new AjxFormat.TextSegment(this,u.text))
}
if(y){
return
}
if(a.length>1){
var g=a[1];
this._negativeFormatter=new AjxNumberFormat(g,true)
}else{
var m=new AjxNumberFormat("");
m._segments=m._segments.concat(this._segments);
var h=s?1:0;
var o=new AjxFormat.TextSegment(m,I18nMsg.numberSignMinus);
m._segments.splice(h,0,o);
this._negativeFormatter=m
}};
AjxNumberFormat.prototype=new AjxFormat;
AjxNumberFormat.prototype.constructor=AjxNumberFormat;
AjxNumberFormat.prototype.toString=function(){
var e=["[AjxNumberFormat: ","formatter=",AjxFormat.prototype.toString.call(this)];
if(this._negativeFormatter){
e.push(", negativeFormatter=",this._negativeFormatter.toString())
}
e.push("]");
return e.join("")
};
AjxNumberFormat._NUMBER="number";
AjxNumberFormat._INTEGER="integer";
AjxNumberFormat._CURRENCY="currency";
AjxNumberFormat._PERCENT="percent";
AjxNumberFormat._META_CHARS="0#.,E";
AjxNumberFormat.prototype._groupingOffset=Number.MAX_VALUE;
AjxNumberFormat.prototype._maxIntDigits;
AjxNumberFormat.prototype._minIntDigits=1;
AjxNumberFormat.prototype._maxFracDigits;
AjxNumberFormat.prototype._minFracDigits;
AjxNumberFormat.prototype._isCurrency=false;
AjxNumberFormat.prototype._isPercent=false;
AjxNumberFormat.prototype._isPerMille=false;
AjxNumberFormat.prototype._showExponent=false;
AjxNumberFormat.prototype._negativeFormatter;
AjxNumberFormat.getInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._NUMBER]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._NUMBER]=new AjxNumberFormat(I18nMsg.formatNumber)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._NUMBER]
};
AjxNumberFormat.getNumberInstance=AjxNumberFormat.getInstance;
AjxNumberFormat.getCurrencyInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._CURRENCY]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._CURRENCY]=new AjxNumberFormat(I18nMsg.formatNumberCurrency)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._CURRENCY]
};
AjxNumberFormat.getIntegerInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._INTEGER]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._INTEGER]=new AjxNumberFormat(I18nMsg.formatNumberInteger)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._INTEGER]
};
AjxNumberFormat.getPercentInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._PERCENT]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._PERCENT]=new AjxNumberFormat(I18nMsg.formatNumberPercent)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._PERCENT]
};
AjxNumberFormat.format=function(t,e){
return new AjxNumberFormat(t).format(e)
};
AjxNumberFormat.initialize=function(){
AjxNumberFormat._FORMATTERS={}
};
AjxNumberFormat.prototype.format=function(e){
if(e<0&&this._negativeFormatter){
return this._negativeFormatter.format(e)
}
return AjxFormat.prototype.format.call(this,e)
};
AjxNumberFormat.prototype.__parseStatic=function(a,t){
var o=[];
while(t<a.length){
var r=a.charAt(t++);
if(AjxNumberFormat._META_CHARS.indexOf(r)!=-1){
t--;
break
}
switch(r){
case"'":var n=t;
while(t<a.length&&a.charAt(t++)!="'"){}
var e=t;
r=e-n==0?"'":a.substring(n,e);
break;
case"%":r=I18nMsg.numberSignPercent;
this._isPercent=true;
break;
case"\u2030":r=I18nMsg.numberSignPerMill;
this._isPerMille=true;
break;
case"\u00a4":r=a.charAt(t)=="\u00a4"?I18nMsg.currencyCode:I18nMsg.currencySymbol;
this._isCurrency=true;
break
}
o.push(r)
}
return{
text:o.join(""),offset:t}
};
AjxNumberFormat.NumberSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxNumberFormat.NumberSegment.prototype=new AjxFormat.Segment;
AjxNumberFormat.NumberSegment.prototype.constructor=AjxNumberFormat.NumberSegment;
AjxNumberFormat.NumberSegment.prototype.toString=function(){
return'number: "'+this._s+'"'
};
AjxNumberFormat.NumberSegment.prototype.format=function(t){
if(isNaN(t)){
return I18nMsg.numberNaN
}
if(t===Number.NEGATIVE_INFINITY||t===Number.POSITIVE_INFINITY){
return I18nMsg.numberInfinity
}
if(typeof t!="number"){
t=Number(t)
}
t=Math.abs(t);
if(this._parent._isPercent){
t*=100
}else{
if(this._parent._isPerMille){
t*=1000
}}
var e=this._parent._showExponent?t.toExponential(this._parent._maxFracDigits).toUpperCase().replace(/E\+/,"E"):t.toFixed(this._parent._maxFracDigits||0);
e=this._normalize(e);
return e
};
AjxNumberFormat.NumberSegment.prototype._normalize=function(r){
var o=r.split(/[\.Ee]/);
var h=o.shift();
if(h.length<this._parent._minIntDigits){
h=AjxFormat._zeroPad(h,this._parent._minIntDigits,I18nMsg.numberZero)
}
if(h.length>this._parent._groupingOffset){
var t=[];
var n=h.length-this._parent._groupingOffset;
while(n>0){
t.unshift(h.substr(n,this._parent._groupingOffset));
t.unshift(I18nMsg.numberSeparatorGrouping);
n-=this._parent._groupingOffset
}
t.unshift(h.substring(0,n+this._parent._groupingOffset));
h=t.join("")
}
var l="0";
var c;
if(r.match(/\./)){
l=o.shift()
}else{
if(r.match(/\e/)||r.match(/\E/)){
c=o.shift()
}}
l=l.replace(/0+$/,"");
if(l.length<this._parent._minFracDigits){
l=AjxFormat._zeroPad(l,this._parent._minFracDigits,I18nMsg.numberZero,true)
}
var t=[h];
if(l.length>0){
var e=this._parent._isCurrency?I18nMsg.numberSeparatorMoneyDecimal:I18nMsg.numberSeparatorDecimal;
t.push(e,l)
}
if(c){
t.push("E",c.replace(/^\+/,""))
}
return t.join("")
};
AjxChoiceFormat=function(s){
if(arguments.length==0){
return
}
AjxFormat.call(this,s);
if(s==null){
return
}
var l=s.split("|");
if(arguments.length==1){
this._limits=new Array(l.length);
this._lessThan=new Array(l.length);
this._formats=new Array(l.length);
var r=new RegExp("^([^#<\u2264]+)([#<\u2264])(.*)$");
for(var a=0;
a<l.length;
a++){
var t=l[a];
var o=r.exec(t);
var e=o[1];
var n=o[2];
var h=o[3];
if(e=="\u221E"){
this._limits[a]=Number.POSITIVE_INFINITY
}else{
if(e=="-\u221E"){
this._limits[a]=Number.NEGATIVE_INFINITY
}else{
this._limits[a]=parseFloat(e)
}}
this._lessThan[a]=n=="#"||n=="\u2264";
this._formats[a]=new AjxMessageFormat(h)
}}else{
this._limits=arguments[0];
this._lessThan=new Array(arguments[0].length);
this._formats=arguments[1];
this._pattern=[];
for(var a=0;
a<this._formats.length;
a++){
if(a>0){
this._pattern.push("|")
}
this._pattern.push(this._limits[a],"#",this._formats[a]);
this._lessThan[a]=false;
this._formats[a]=new AjxMessageFormat(this._formats[a])
}
this._pattern=this._pattern.join("")
}};
AjxChoiceFormat.prototype=new AjxFormat;
AjxChoiceFormat.prototype.constructor=AjxChoiceFormat;
AjxChoiceFormat.prototype.toString=function(){
return["[AjxChoiceFormat: ","limits={ ",this._limits.join(", ")," }, ","formats={ ",this._formats.join(", ")," }, ","lessThan={ ",this._lessThan.join(", ")," }]"].join("")
};
AjxChoiceFormat.prototype._limits;
AjxChoiceFormat.prototype._lessThan;
AjxChoiceFormat.prototype._formats;
AjxChoiceFormat.prototype.getLimits=function(){
return this._limits
};
AjxChoiceFormat.prototype.getFormats=function(){
return this._formats
};
AjxChoiceFormat.prototype.format=function(e,n){
var o=e instanceof Array?e[n]:e;
var l;
if(isNaN(o)||o<this._limits[0]){
l=this._formats[0]
}else{
for(var t=0;
t<this._limits.length-1;
t++){
var h=this._limits[t];
var r=this._limits[t+1];
var c=o>=h;
var s=this._lessThan[t+1]?o<r:o<=r;
if(c&&s){
l=this._formats[t];
break
}}
if(!l){
l=this._formats[this._formats.length-1]
}}
return l.format(e)
};
AjxListFormat=function(e,a,t){
if(arguments.length==0){
return
}
AjxFormat.call(this,e?e.toPattern():"");
this._formatter=e;
this._separator=a||AjxMsg.listSeparator;
this._lastSeparator=t||AjxMsg.listSeparatorLast
};
AjxListFormat.prototype=new AjxFormat;
AjxListFormat.prototype.constructor=AjxListFormat;
AjxListFormat.prototype._formatter;
AjxListFormat.prototype._separator;
AjxListFormat.prototype._lastSeparator;
AjxListFormat.prototype.format=function(o){
o=o instanceof Array?o:[o];
var a=[];
for(var e=0;
e<o.length;
e++){
if(e>0){
a.push(e<o.length-1?this._separator:this._lastSeparator)
}
var t=o[e];
a.push(this._formatter?this._formatter.format(t):String(t))
}
return a.join("")
};
AjxFormat.initialize();
