
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxUtil=function(){};
AjxUtil.FLOAT_RE=/^[+\-]?((\d+(\.\d*)?)|((\d*\.)?\d+))([eE][+\-]?\d+)?$/;
AjxUtil.NOTFLOAT_RE=/[^\d\.]/;
AjxUtil.NOTINT_RE=/[^0-9]+/;
AjxUtil.LIFETIME_FIELD=/^([0-9])+([dhms]|ms)?$/;
AjxUtil.isSpecified=function(e){
return((e!==void 0)&&(e!==null))
};
AjxUtil.isUndefined=function(e){
return(e===void 0)
};
AjxUtil.isNull=function(e){
return(e===null)
};
AjxUtil.isBoolean=function(e){
return(typeof(e)=="boolean")
};
AjxUtil.isString=function(e){
return(typeof(e)=="string")
};
AjxUtil.isNumber=function(e){
return(typeof(e)=="number")
};
AjxUtil.isObject=function(e){
return((typeof(e)=="object")&&(e!==null))
};
AjxUtil.isArray=function(e){
return AjxUtil.isInstance(e,Array)
};
AjxUtil.isFunction=function(e){
return(typeof(e)=="function")
};
AjxUtil.isDate=function(e){
return AjxUtil.isInstance(e,Date)
};
AjxUtil.isLifeTime=function(e){
return AjxUtil.LIFETIME_FIELD.test(e)
};
AjxUtil.isNumeric=function(e){
return(!isNaN(parseFloat(e))&&AjxUtil.FLOAT_RE.test(e)&&!AjxUtil.NOTFLOAT_RE.test(e))
};
AjxUtil.isLong=function(e){
return(AjxUtil.isNumeric(e)&&!AjxUtil.NOTINT_RE.test(e))
};
AjxUtil.isNonNegativeLong=function(e){
return(AjxUtil.isNumeric(e)&&AjxUtil.isLong(e)&&(parseFloat(e)>=0))
};
AjxUtil.isInt=function(e){
return(AjxUtil.isNumeric(e)&&!AjxUtil.NOTINT_RE.test(e))
};
AjxUtil.isPositiveInt=function(e){
return(AjxUtil.isNumeric(e)&&AjxUtil.isInt(e)&&(parseInt(e)>0))
};
AjxUtil.isEmpty=function(e){
return(AjxUtil.isNull(e)||AjxUtil.isUndefined(e)||(e==="")||(AjxUtil.isArray(e)&&(e.length==0)))
};
AjxUtil.IP_ADDRESS_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?$/;
AjxUtil.IP_ADDRESS_WITH_PORT_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?:\d{1,5}$/;
AjxUtil.SUBNET_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?\/\d{1,2}$/;
AjxUtil.DOMAIN_NAME_SHORT_RE=/^[A-Za-z0-9\-]{2,}$/;
AjxUtil.DOMAIN_NAME_FULL_RE=/^[A-Za-z0-9\-]{1,}(\.[A-Za-z0-9\-]{2,}){1,}$/;
AjxUtil.HOST_NAME_RE=/^[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{1,})*(\.[A-Za-z0-9\-]{2,})*$/;
AjxUtil.HOST_NAME_WITH_PORT_RE=/^[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{2,})*:([0-9])+$/;
AjxUtil.EMAIL_SHORT_RE=/^[^@\s]+$/;
AjxUtil.EMAIL_FULL_RE=/^[^@\s]+@[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{2,})+$/;
AjxUtil.SHORT_URL_RE=/^[A-Za-z0-9]{2,}:\/\/[A-Za-z0-9\-]+(\.[A-Za-z0-9\-]+)*(:([0-9])+)?$/;
AjxUtil.IP_SHORT_URL_RE=/^[A-Za-z0-9]{2,}:\/\/\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?(:([0-9])+)?$/;
AjxUtil.isIpAddress=function(e){
return AjxUtil.IP_ADDR_RE.test(e)
};
AjxUtil.isDomain=function(e){
return AjxUtil.DOMAIN_RE.test(e)
};
AjxUtil.isHostName=function(e){
return AjxUtil.HOST_NAME_RE.test(e)
};
AjxUtil.isDomainName=function(t,e){
return e?AjxUtil.DOMAIN_NAME_SHORT_RE.test(t):AjxUtil.DOMAIN_NAME_FULL_RE.test(t)
};
AjxUtil.isEmailAddress=function(t,e){
return e?AjxUtil.EMAIL_SHORT_RE.test(t):AjxUtil.EMAIL_FULL_RE.test(t)
};
AjxUtil.isValidEmailNonReg=function(e){
return((e.indexOf("@")>0)&&(e.lastIndexOf("@")==e.indexOf("@"))&&(e.indexOf(".@")<0))
};
AjxUtil.SIZE_GIGABYTES="GB";
AjxUtil.SIZE_MEGABYTES="MB";
AjxUtil.SIZE_KILOBYTES="KB";
AjxUtil.SIZE_BYTES="B";
AjxUtil.formatSize=function(o,i,n){
if(i==null){
i=true
}
if(n==null){
n=20
}
var t=AjxMsg.sizeBytes;
var a=AjxMsg.SIZE_BYTES;
if(o>=1073741824){
t=AjxMsg.sizeGigaBytes;
a=AjxUtil.SIZE_GIGABYTES
}else{
if(o>=1048576){
t=AjxMsg.sizeMegaBytes;
a=AjxUtil.SIZE_MEGABYTES
}else{
if(o>1023){
t=AjxMsg.sizeKiloBytes;
a=AjxUtil.SIZE_KILOBYTES
}}}
var e=AjxUtil.formatSizeForUnits(o,a,i,n);
return AjxMessageFormat.format(AjxMsg.formatSizeAndUnits,[e,t])
};
AjxUtil.formatSizeForUnits=function(o,t,e,s){
if(t==null){
t=AjxUtil.SIZE_BYTES
}
if(e==null){
e=true
}
if(s==null){
s=20
}
switch(t){
case AjxUtil.SIZE_GIGABYTES:o/=1073741824;
break;
case AjxUtil.SIZE_MEGABYTES:o/=1048576;
break;
case AjxUtil.SIZE_KILOBYTES:o/=1024;
break
}
var n=I18nMsg.formatNumber.replace(/\..*$/,"");
n=n.replace(/,/,"");
if(!e&&s){
n=n+=".";
for(var a=0;
a<s;
a++){
n+="#"
}}
return AjxNumberFormat.format(n,o)
};
AjxUtil.parseSize=function(t,i){
if(typeof t!=_STRING_){
t=t.toString()
}
var o=parseFloat(t.replace(/^\s*/,""));
var a=/[GMK]?B$/i;
var e=a.exec(t);
if(e){
i=e[0].toUpperCase()
}
switch(i){
case AjxUtil.SIZE_GIGABYTES:o*=1073741824;
break;
case AjxUtil.SIZE_MEGABYTES:o*=1048576;
break;
case AjxUtil.SIZE_KILOBYTES:o*=1024;
break
}
return o
};
AjxUtil.isInstance=function(e,t){
return !!(e&&e.constructor&&(e.constructor===t))
};
AjxUtil.assert=function(e,t){
if(!e&&AjxUtil.onassert){
AjxUtil.onassert(t)
}};
AjxUtil.onassert=function(t){
var l=new Object();
l.message=t;
var c=new Array();
if(AjxEnv.isIE5_5up){
var o=arguments.callee.caller;
var n=0;
while(o&&n++<20){
c[c.length]=o;
o=o.caller
}}else{
try{
var o=arguments.callee.caller;
while(o){
c[c.length]=o;
if(c.length>2){
break
}
o=o.caller
}}
catch(h){}}
l.stack=c;
var r="";
var a=170;
for(var n=1;
n<c.length;
n++){
if(n>1){
r+="\n"
}
if(n<11){
var s=c[n].toString();
if(s.length>a){
s=s.substr(0,a)+"...";
s=s.replace(/\n/g,"")
}
r+=n+": "+s
}else{
r+="("+(c.length-11)+" frames follow)";
break
}}
alert("assertion:\n\n"+t+"\n\n---- Call Stack ---\n"+r);
throw l
};
AjxUtil.ELEMENT_NODE=1;
AjxUtil.TEXT_NODE=3;
AjxUtil.DOCUMENT_NODE=9;
AjxUtil.getInnerText=function(e){
if(AjxEnv.isIE){
return e.innerText
}
function t(s){
if(s){
if(s.nodeType==3){
return s.data
}
if(s.nodeType==1){
if(/^br$/i.test(s.tagName)){
return"\r\n"
}
var o="";
for(var a=s.firstChild;
a;
a=a.nextSibling){
o+=t(a)
}
return o
}}
return""
}
return t(e)
};
AjxUtil.createProxy=function(a,s){
var o;
var t=function(){};
t.prototype=a;
if(a instanceof Array){
o=new Array();
var i=a.length;
for(var e=0;
e<i;
e++){
o[e]=a[e]
}}else{
o=new t
}
if(s){
for(var n in a){
if(typeof a[n]=="object"&&a[n]!==null){
o[n]=AjxUtil.createProxy(a[n],s-1)
}}}
o._object_=a;
return o
};
AjxUtil.unProxy=function(t){
var e=t&&t._object_;
if(e){
for(var a in t){
if(t.hasOwnProperty(a)&&a!="_object_"){
e[a]=t[a]
}}
return e
}
return null
};
AjxUtil.collapseList=function(a){
var t=[];
for(var e=0;
e<a.length;
e++){
if(a[e]){
t.push(a[e])
}}
return t
};
AjxUtil.arrayAsHash=function(r,o){
var s={};
var a=typeof o=="function"&&o;
var n=o||true;
for(var t=0;
t<r.length;
t++){
var e=r[t];
s[e]=a?a(e,s,t,r):n
}
return s
};
AjxUtil.arrayAdd=function(a,t,e){
if(e==null||e<0||e>=a.length){
a.push(t)
}else{
a.splice(e,0,t)
}};
AjxUtil.arrayRemove=function(a,t){
if(a){
for(var e=0;
e<a.length;
e++){
if(a[e]==t){
a.splice(e,1);
return true
}}}
return false
};
AjxUtil.indexOf=function(n,t,e){
if(n){
for(var a=0;
a<n.length;
a++){
var o=n[a];
if((e&&o===t)||(!e&&o==t)){
return a
}}}
return -1
};
AjxUtil.keys=function(t,e){
var a=[];
for(var i in t){
if(e&&!e(i,t)){
continue
}
a.push(i)
}
return a
};
AjxUtil.values=function(a,t){
var e=[];
for(var i in a){
if(t&&!t(i,a)){
continue
}
e.push(a[i])
}
return e
};
AjxUtil.foreach=function(a,t){
if(!t){
return
}
for(var e=0;
e<a.length;
e++){
t(a[e],e)
}};
AjxUtil.map=function(o,a){
var e=new Array(o.length);
for(var t=0;
t<o.length;
t++){
e[t]=a?a(o[t],t):o[t]
}
return e
};
AjxUtil.uniq=function(a){
var e={};
for(var t=0;
t<a.length;
t++){
e[a[t]]=true
}
return AjxUtil.keys(e)
};
AjxUtil.concat=function(t){
var a=[];
for(var e=0;
e<arguments.length;
e++){
a.push.apply(a,arguments[e])
}
return a
};
AjxUtil.union=function(e){
var t=[];
return AjxUtil.uniq(t.concat.apply(t,arguments))
};
AjxUtil.intersection=function(t){
var i=AjxUtil.concat.apply(this,arguments);
var e=AjxUtil.arrayAsHash(i,AjxUtil.__intersection_count);
for(var a in e){
if(e[a]==1){
delete e[a]
}}
return AjxUtil.keys(e)
};
AjxUtil.__intersection_count=function(t,a,e,i){
return a[t]!=null?a[t]+1:1
};
AjxUtil.complement=function(i,t){
var a=AjxUtil.arrayAsHash(i);
var e=AjxUtil.arrayAsHash(t);
for(var o in e){
if(o in a){
delete e[o]
}}
return AjxUtil.keys(e)
};
AjxUtil.getFirstElement=function(o,i,a,t){
for(var n=o.firstChild;
n;
n=n.nextSibling){
if(n.nodeType!=AjxUtil.ELEMENT_NODE){
continue
}
if(i&&n.nodeName!=i){
continue
}
if(a){
var e=n.getAttributeNode(a);
if(e.nodeName!=a){
continue
}
if(t&&e.nodeValue!=t){
continue
}}
return n
}
return null
};
AjxUtil.formatUrl=function(s){
s=s||{};
var a=[];
var o=0;
if(!s.relative){
var n=s.protocol||location.protocol;
if(n.indexOf(":")==-1){
n=n+":"
}
a[o++]=n;
a[o++]="//";
a[o++]=s.host||location.hostname;
var t=Number(s.port||location.port);
if(t&&((n==ZmSetting.PROTO_HTTP&&t!=ZmSetting.HTTP_DEFAULT_PORT)||(n==ZmSetting.PROTO_HTTPS&&t!=ZmSetting.HTTPS_DEFAULT_PORT))){
a[o++]=":";
a[o++]=t
}}
a[o++]=s.path||location.pathname;
var e="";
if(s.qsArgs){
e=AjxStringUtil.queryStringSet(s.qsArgs,s.qsReset)
}else{
e=s.qsReset?"":location.search
}
a[o++]=e;
return a.join("")
};
AjxUtil.byNumber=function(t,e){
return Number(t)-Number(e)
};
AjxUtil.byStringProp=function(i,t,e){
return t[i].localeCompare(e[i])
};
AjxUtil.mergeArrays=function(h,n,e){
if(!e){
e=AjxUtil.__mergeArrays_orderfunc
}
var l=[];
var o=h.length;
for(var t=0;
t<o;
t++){
l.push(h[t])
}
var s=[];
var a=n.length;
for(var t=0;
t<a;
t++){
s.push(n[t])
}
var r=[];
while(l.length>0&&s.length>0){
if(e(l[0],r[r.length-1])==0){
l.shift();
continue
}
if(e(s[0],r[r.length-1])==0){
s.shift();
continue
}
if(e(l[0],s[0])<0){
r.push(l.shift())
}else{
if(e(l[0],s[0])==0){
r.push(l.shift());
s.shift()
}else{
r.push(s.shift())
}}}
while(l.length>0){
if(e(l[0],r[r.length-1])==0){
l.shift();
continue
}
r.push(l.shift())
}
while(s.length>0){
if(e(s[0],r[r.length-1])==0){
s.shift();
continue
}
r.push(s.shift())
}
return r
};
AjxUtil.__mergeArrays_orderfunc=function(t,e){
if(t>e){
return 1
}
if(t<e){
return -1
}
if(t==e){
return 0
}};
AjxUtil.arraySubstract=function(h,n,e){
if(!e){
e=function(c,i){
if(c>i){
return 1
}
if(c<i){
return -1
}
if(c==i){
return 0
}}
}
var l=[];
var o=h.length;
for(var t=0;
t<o;
t++){
l.push(h[t])
}
var s=[];
var a=n.length;
for(var t=0;
t<a;
t++){
s.push(n[t])
}
s.sort(e);
l.sort(e);
var r=[];
while(l.length>0&&s.length>0){
if(e(l[0],s[0])==0){
l.shift();
s.shift();
continue
}
if(e(l[0],s[0])<0){
r.push(l.shift());
continue
}
if(e(l[0],s[0])>0){
s.shift();
continue
}}
while(l.length>0){
r.push(l.shift())
}
return r
};
AjxUtil.getHashKeys=function(a){
var t=[];
for(var e in a){
t.push(e)
}
t.sort();
return t
};
AjxUtil.arrayCompare=function(t,e){
if((!t||!e)&&(t!=e)){
return false
}
if(t.length!=e.length){
return false
}
for(var a=0;
a<t.length;
a++){
if(t[a]!=e[a]){
return false
}}
return true
};
AjxUtil.hashCompare=function(r,s){
var a=AjxUtil.getHashKeys(r);
var t=AjxUtil.getHashKeys(s);
if(!AjxUtil.arrayCompare(a,t)){
return false
}
for(var n=0,e=a.length;
n<e;
n++){
var o=a[n];
if(r[o]!=s[o]){
return false
}}
return true
};
AjxUtil.hashCopy=function(t){
var a={};
for(var e in t){
a[e]=t[e]
}
return a
};
AjxUtil.hashUpdate=function(i,a,e,o){
for(var t in a){
if((e||!(t in i))&&(!o||AjxUtil.indexOf(o,t)==-1)){
i[t]=a[t]
}}
return i
};
AjxUtil.isArray1=function(e){
return Boolean(e&&(e.length!=null)&&e.splice&&e.slice)
};
AjxUtil.toArray=function(e){
return AjxUtil.isArray1(e)?e:(e===undefined)?[]:[e]
};
AjxUtil.get=function(e){
for(var t=1;
e&&t<arguments.length;
t++){
e=e[arguments[t]]
}
return e
};
